#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>
#include <hpdir.h>

int hpd_rcl_int (char *name, LONGLONG *val)
{
	int Ret = HPD_OK;

	if (name && val)
	{
		SAT_OBJ_DSCR *dirobj;

		// Gets the dir object		
		if (dirobj = sat_dir_rclobject (name))
		{	
			int type;
			hpobj_t obj;
			int incr;
			obj.type = 0;
	
			// Gets the type of the object
			type = sat_peek (dirobj->addr, 5);
						
			// Deals with the type
			switch (type)
			{
				case DOINT :		// Requested type => no conversion needed
				{
					// Decodes the object
					(void) hps_decode_int (dirobj->addr, &obj, &incr);
					*val = obj.data.doint;
						
					break;
				}
					
				case DOHXS :		// Conversion needed if authorized
				{
					if (hps_get_convert ())	// Checks for conversion flag
					{
						// Decodes the object
						(void) hps_decode_uint (dirobj->addr, &obj, &incr);
						*val = (LONGLONG) obj.data.dohxs;
					}
					else
					{
						Ret = HPD_ERROR_TYPE;
					}

					break;
				}

				case DOREAL :		// Conversion needed if authorized
				{
					if (hps_get_convert ())	// Checks for conversion flag
					{
						// Decodes the object
						(void) hps_decode_real (dirobj->addr, &obj, &incr);
						*val = (LONGLONG) obj.data.doreal;
					}
					else
					{
						Ret = HPD_ERROR_TYPE;
					}

					break;
				}
					
				default :				// No conversion possible : type mismatch
				{
					Ret = HPD_ERROR_TYPE;
					break;
				}
			}
		}
		else
		{
			Ret = HPD_ERROR_NOT_FOUND;
		}
	}
	else
	{
		Ret = HPD_ERROR_PAR;
	}
	
	return (Ret);
}
