#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_code_array (array_t *val, unsigned *address)
{
	int Ret = HPS_OK;

	if (val && address)
	{
		int size = 0;

		if ((Ret = hps_objsize_type (DOMATRIX, (void *) &val, &size)) == HPS_OK)
		{
			unsigned addr;
			
			if (addr = (*address ? *address : (*address = sat_createtemp (size))))
			{
				array_t *cur = val;
							
				// Fills the prologue
				sat_poke (addr, DOMATRIX, 5);
				addr += 5;
								
				// Puts the elements
				while (cur)
				{
					if (cur->obj)
					{
						if ((Ret = hps_code (cur->obj, &addr)) == HPS_OK)
						{
							int s;
										
							(void) hps_objsize (cur->obj, &s);
							addr += s;
						}
						else
						{
							break;
						}
					}
									
					cur = cur->next;
				}
			
				// Fills the epilogue
				sat_poke (addr, SEMI, 5);
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
