#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_decode_real (unsigned address, hpobj_t *obj, int *incr)
{
	int Ret = HPS_OK;
	unsigned prolog;
	
	if (obj && incr)
	{
		if (obj->type)
		{
			prolog = obj->type;							// There is no prologue (used by DOARRY)
			*incr = 0;
		}
		else
		{
			prolog = sat_peek (address, 5);
			address += 5;									// Skips the prologue
			*incr = 5;
		}

		switch (prolog)
		{
			case REAL_m9 :
			{
				obj->type = DOREAL;
				obj->data.doreal = -9.;
				break;
			}
			
			case REAL_m8 :
			{
				obj->type = DOREAL;
				obj->data.doreal = -8.;
				break;
			}
			
			case REAL_m7 :
			{
				obj->type = DOREAL;
				obj->data.doreal = -7.;
				break;
			}
			
			case REAL_m6 :
			{
				obj->type = DOREAL;
				obj->data.doreal = -6.;
				break;
			}
			
			case REAL_m5 :
			{
				obj->type = DOREAL;
				obj->data.doreal = -5.;
				break;
			}
			
			case REAL_m4 :
			{
				obj->type = DOREAL;
				obj->data.doreal = -4.;
				break;
			}
			
			case REAL_m3 :
			{
				obj->type = DOREAL;
				obj->data.doreal = -3.;
				break;
			}
			
			case REAL_m2 :
			{
				obj->type = DOREAL;
				obj->data.doreal = -2.;
				break;
			}
			
			case REAL_m1 :
			{
				obj->type = DOREAL;
				obj->data.doreal = -1.;
				break;
			}
			
			case REAL_0 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 0.;
				break;
			}
			
			case REAL_1 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 1.;
				break;
			}
			
			case REAL_2 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 2.;
				break;
			}
			
			case REAL_3 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 3.;
				break;
			}
			
			case REAL_4 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 4.;
				break;
			}
			
			case REAL_5 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 5.;
				break;
			}
			
			case REAL_6 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 6.;
				break;
			}
			
			case REAL_7 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 7.;
				break;
			}
			
			case REAL_8 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 8.;
				break;
			}
			
			case REAL_9 :
			{
				obj->type = DOREAL;
				obj->data.doreal = 9.;
				break;
			}

			case xPI :
			{
				obj->type = DOREAL;
				obj->data.doreal = 3.14159265359;
				break;
			}
			
			case xe :
			{
				obj->type = DOREAL;
				obj->data.doreal = 2.71828182846;
				break;
			}
			
			case DOREAL :
			{
				double val;
				
				// Decodes the real value
				val = real2double (address);
				
				// Sets the output parameters
				obj->type = DOREAL;
				*incr += 16;			// 3 (exp) +12 (digits) + 1 (sign)
				obj->data.doreal = val;
					
				break;
			}
				
			default :
			{
				Ret = HPS_ERROR_TYPE;
				break;
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
