#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_decode_str (unsigned address, hpobj_t *obj, int *incr)
{
	int Ret = HPS_OK;
	unsigned prolog;
	
	if (obj && incr)
	{
		if (obj->type)
		{
			prolog = obj->type;							// There is no prologue (used by DOARRY)
			*incr = 0;
		}
		else
		{
			prolog = sat_peek (address, 5);
			address += 5;									// Skips the prologue
			*incr = 5;
		}
			
		switch (prolog)
		{
			case DOCSTR :
			{
				// Gets the size
				unsigned int nb = sat_peek (address, 5) - 5;
				char *val;
				int ind;
	
				// Allocates the C string
				val = obj->data.docstr = (char *) malloc (nb/2 + 1);
					
				if (val)
				{
					// Gets the string
					for (ind = 0; ind < nb/2; ind++)
					{
						unsigned c;
						
						c = sat_peek (address + 5 + 2*ind, 2);
						val[ind] = (char) c;
					}
					val[nb/2] = '\0';
				}
				else
				{
					Ret = HPS_ERROR_ARM_MEMORY;
				}
					
				// Sets the output parameters
				obj->type = DOCSTR;
				*incr += 5 + nb;
	
				break;
			}
			
			default :
			{
				Ret = HPS_ERROR_TYPE;
				break;
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
