#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_decode_uint (unsigned address, hpobj_t *obj, int *incr)
{
	int Ret = HPS_OK;
	unsigned prolog;
	
	if (obj && incr)
	{
		if (obj->type)
		{
			prolog = obj->type;							// There is no prologue (used by DOARRY)
			*incr = 0;
		}
		else
		{
			prolog = sat_peek (address, 5);
			address += 5;									// Skips the prologue
			*incr = 5;
		}
			
		switch (prolog)
		{
			case DOHXS :		// UINT -> unsigned long long
			{
				// Gets size of int (always 16 ?)
				unsigned int nb = sat_peek (address, 5) - 5;
					
				// Checks for overflow
				if (nb < 19)				// long long max = 1.844 e19
				{
					ULONGLONG val = 0;
						
					// Gets the value
					val = BCD2val (address + 5, nb - 1, 16);
										
					// Sets the output parameters
					obj->type = DOHXS;
					obj->data.dohxs = val;
				}
				else
				{
					Ret = HPS_ERROR_OVERFLOW;
				}

				*incr += 21;				// size + data
				break;
			}

			default :
			{
				Ret = HPS_ERROR_TYPE;
				break;
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
