#ifndef __HPSTDIO_H
#define __HPSTDIO_H	1

#include <stdio.h>
#include <stdarg.h>
#include "hpsys.h"
#include "kos.h"

extern int hpgcc_vsprintf(char *out, const char *fmt, va_list argp);
extern int hpgcc_sprintf(char *out, const char *fmt, ...);
extern int hpgcc_fprintf(FILE * f, const char *fmt, ...);
extern int hpgcc_printf(const char *fmt, ...);

extern int hpgcc_fputc(int c, FILE * f);
extern int hpgcc_fputs(const char *s, FILE * f);
extern void hpgcc_putc(int c);
extern int hpgcc_putchar(int c);
extern int hpgcc_puts(const char *str);

#ifndef DONT_USE_HPGCC_LIBC
#undef printf
#define printf	hpgcc_printf

#undef vsprintf
#define vsprintf	hpgcc_vsprintf

#undef sprintf
#define sprintf	hpgcc_sprintf

#undef fprintf
#define fprintf	hpgcc_fprintf

#undef fputc
#define fputc		hpgcc_fputc

#undef fputs
#define fputs		hpgcc_fputs

#undef puts
#define puts		hpgcc_fputs

#undef putchar
#define putchar	hpgcc_putchar
#endif

#define iprintf		printf
#define isprintf	sprintf
#define ivsprintf	vsprintf
#define ifprintf	fprintf



#ifndef _LONGLONG_DEF
typedef unsigned long long ULONGLONG;
typedef long long LONGLONG;
#define _LONGLONG_DEF
#endif


extern unsigned char *get_minifont();
extern unsigned char *get_bigfont();
extern int get_bigfontheight();


extern int readint();
extern unsigned readuint();
extern unsigned readhex();
extern LONGLONG readlonglong();
extern ULONGLONG readulonglong();
extern double readdouble();


extern int get_decimal_digits();
extern void set_decimal_digits(int v);
extern char *get_decimal_separator();
extern void set_decimal_separator(char a);


#endif
