#ifndef _HPSTRING_H
#define _HPSTRING_H	1

#ifndef _LONGLONG_DEF
typedef unsigned long long ULONGLONG;
typedef long long LONGLONG;
#define _LONGLONG_DEF
#endif

#include <string.h>
#include "hpctype.h"


extern void memcpyw(void *dest, const void *source, int nwords);
extern void memsetw(void *dest, int value, int nwords);
extern char *strset(char *s, int fill);

extern char *str_unquote(char *s, char c);
extern char *upper(char *t, const char *s);
extern char *lower(char *t, const char *s);


extern char *itoa(int z, char *buff, int base);
extern char *utoa(unsigned z, char *buff, int base);
extern char *lltoa(LONGLONG, char *, int base);
extern char *ulltoa(ULONGLONG, char *, int base);

#ifndef DOXYGEN_SKIP
extern char *__dtoa(double x, char *buf, char exp_sym);

extern char *xpad(char *t, char *s, int n, int left, char c);

extern int atoi_base(char *, int base);
extern unsigned atoui_base(char *, int base);
extern LONGLONG atoll_base(char *, int base);
extern ULONGLONG atoull_base(char *, int base);
#endif

extern unsigned atoui(char *);
extern ULONGLONG atoull(char *);

extern char *ints(int z, int base);
extern char *uints(unsigned z, int base);

#endif
