#ifndef _HPSYS_H
#define _HPSYS_H	1


#ifndef _LONGLONG_DEF
typedef unsigned long long ULONGLONG;
typedef long long LONGLONG;
#define _LONGLONG_DEF
#endif


#include "kos.h"

#include <stdlib.h>
#include <time.h>


extern char *sys_bcd2str(unsigned int BCD);

extern unsigned int sys_bcd2bin_nibbles(unsigned int BCD, int nibbles);
#define sys_bcd2bin(BCD) sys_bcd2bin_nibbles(BCD,2)



unsigned int divlu2(unsigned int num_h, unsigned int num_l,
		    unsigned int den, unsigned int *rem);


ULONGLONG udiv64(ULONGLONG nom, unsigned int den, unsigned int *rem);
LONGLONG sdiv64(LONGLONG nom, int den, int *rem);


/* loader globals */
/*
extern unsigned int _ram_base_addr;
extern unsigned int _mmu_table_addr;
extern unsigned int ram_size;
extern unsigned int _heap_base_addr;
extern unsigned int _code_base_addr;
*/

/* HARDWARE CONSTANTS */

/*
#define LCD_REGS    0x07300000
#define CLK_REGS    0x07200000
#define RTC_REGS    0x07B00000
*/

extern void sys_intOff(void);
extern void sys_intOn(void);

extern void sys_slowOn(void);
extern void sys_slowOff(void);
extern int sys_is_slowOn(void);

extern void sys_clksave(int *buf);
extern void sys_clkrestore(int *buf);




/* time related routines */

typedef struct {
    ULONGLONG current;
    unsigned int last_val:16;
    unsigned int timer:3;
    unsigned int inited:1;
} sys_timer_t;

#define SYS_TIMER_INITIALIZER { 0, 0, 0, 0 }
#define SYS_TIMER_INITIALIZER_NUM(n) { 0, 0, n, 0 }

extern ULONGLONG sys_updateTimer(sys_timer_t * timer);

extern void sys_sleep(unsigned int millis);


extern void sys_waitTicks(unsigned int time);
extern void sys_setupTimers(void);
extern void sys_restoreTimers(void);


extern unsigned short int sys_getPWMCounter0(void);


extern int sys_RTC_seconds(void);



/* VIDEO MODE CONSTANTS */
#define MODE_MONO 0
#define MODE_4GRAY 1
#define MODE_16GRAY 2

extern void sys_LCDSynch(void);
extern void sys_lcdfix(void);
extern void sys_lcdsave(int *buffer);
extern void sys_lcdrestore(int *buffer);
extern int sys_lcdsetmode(int mode, int *physicalbuffer);
extern int sys_lcdgetheight(void);




extern int sys_map_v2p(unsigned int vaddr);
extern int sys_map_p2v(unsigned int paddr);
extern int sys_mem_classify(int addr);
extern void sys_flush_cache(int *ptr, int size);

extern void *sys_phys_malloc(size_t);


extern void sys_playTone(unsigned int tone, unsigned int duration);
extern void sys_waitTicks(unsigned int time);
extern void setDisplayPlane(unsigned char *plane);

extern void sys_playTone2(unsigned int time, unsigned int duration);

extern int sys_isRTCTick();
extern unsigned char sys_setRTCTickPeriod(unsigned char n);
extern void sys_waitRTCTicks(int count);


extern int sys_delta_seconds(int t_start, int t_end);


extern void sys_error(const char *msg, int code);
extern void *sys_chkptr(void *p);



#endif
