#ifndef __HPSATURN_H
#define __HPSATURN_H	1

#define DEFAULT_RAM_SIZE	240000
extern int _ram_size;



#ifndef _LONGLONG_DEF
typedef unsigned long long ULONGLONG;
typedef long long LONGLONG;
#define _LONGLONG_DEF
#endif


#define SWAP4(x) (((x) << 4) | ((x) >> 4))
#define ALIGN(x,a) (((unsigned)(x)+(a)-1) & (~((unsigned)(a)-1)))

#ifndef BOOL
#define BOOL int
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE !FALSE
#endif


/*
typedef struct _sat_cpu {
    unsigned int Read[257];
    unsigned int Write[257];
    unsigned char unknown_data[260];
    unsigned int A;
    unsigned int Ah;
    unsigned int B;
    unsigned int Bh;
    unsigned int C;
    unsigned int Ch;
    unsigned int D;
    unsigned int Dh;

    unsigned int R0;
    unsigned int R0h;
    unsigned int R1;
    unsigned int R1h;
    unsigned int R2;
    unsigned int R2h;
    unsigned int R3;
    unsigned int R3h;
    unsigned int R4;
    unsigned int R4h;

    unsigned int D0;
    unsigned int D1;
    unsigned int P;
    unsigned int ST;
    unsigned int HST;
    unsigned int CARRY;
    unsigned int DECIMAL_MODE;

} SAT_CPU, *SAT_PCPU;
*/

/*!
 * \brief An RPL List Object. 
 */

typedef struct sat_list_struct {
    unsigned int size;
    unsigned char *data;
} *SAT_LIST;

/*
extern SAT_CPU *_saturn_cpu;
*/


/* SATURN Stack */

#define SAT_STACK_BIAS 1


typedef struct _sat_stack_element {
    unsigned addr;
    unsigned prologue;

} SAT_STACK_ELEMENT, *SAT_PSTACK_ELEMENT;



#define SAT_DOINT	0x2614
#define SAT_DOCSTR	0x2a2c
#define SAT_DOREAL	0x2933
#define SAT_DOEREL	0x2955
#define SAT_DOHXS	0x2a4e
#define SAT_DOBINT	0x2911
#define SAT_DOCMP	0x2977
#define SAT_DOECMP	0x299D
#define SAT_DOCHAR	0x29BF
#define SAT_DOARRY	0x29e8
#define SAT_DOLNKARRY	0x29e8
#define SAT_DOIDNT	0x2e48
#define SAT_DOLAM	0x2e6D
#define SAT_DOROMP	0x2e92
#define SAT_DORRP	0x2a96
#define SAT_DOSYMB	0x2AB8
#define SAT_DOLIST	0x2A74
#define SAT_DOCOL	0x2D9D
#define SAT_DOGROB	0x2B1E
#define SAT_SEMI	0x312b
#define SAT_DOBAK	0x2B62
#define SAT_DOCODE	0x2DCC
#define SAT_DOEXT	0x2ADA
#define SAT_DOFLASHP	0x26AC
#define SAT_DOLIB	0x2B40
#define SAT_DOMATRIX	0x2686
#define SAT_DOTAG	0x2AFC
#define SAT_DOAPLET	0x26D5
#define SAT_DOEXT0	0x2B88
#define SAT_DOACPTR	0x2BAA
#define SAT_DOEXT1	SAT_DOACPTR
#define SAT_DOEXT2	0x2BCC
#define SAT_DOEXT3	0x2BEE
#define SAT_DOEXT4	0x2C10
#define SAT_DOLNGREAL	0x263A
#define SAT_DOLNGCOMP	0x2660


#define REAL_0	0x2f937
#define REAL_1	0x2f94c
#define REAL_2	0x2f961
#define REAL_3	0x2f976
#define REAL_4	0x2f98b
#define REAL_5	0x2f9a0
#define REAL_6	0x2f9b5
#define REAL_7	0x2f9ca
#define REAL_8	0x2f9df
#define REAL_9	0x2f9f4



/* OBSOLETE CONSTANTS: KEPT FOR COMPATIBILITY ONLY */
#define SAT_PROLOGUE_STRING SAT_DOCSTR
#define SAT_PROLOGUE_UINT SAT_DOHXS

#define SAT_DATA_TYPE_INT        28
#define SAT_DATA_TYPE_LONG        10
#define SAT_DATA_TYPE_STRING        2
#define SAT_DATA_TYPE_REAL        0
#define SAT_DATA_TYPE_UNSUPPORTED -999


typedef struct _sat_stack_data {
    int type;
    union {
	int ival;
	double dval;
	LONGLONG lval;
	char *sval;
    }
#ifdef __STRICT_ANSI__
    val		/* ANCI C doesn't allow anonymous structs */
#endif
    ;
} SAT_STACK_DATA, *SAT_PSTACK_DATA;


/* general SAT hacking functions */

void sat_poke(int sat_addr, unsigned val, int nibbles);
void sat_poke_nibbles(unsigned sat_addr, const char *data, int nibbles);
unsigned sat_peek(int sat_addr, int nibbles);
void sat_memmove(int satsrc, int satdest, int nibbles);

#define sat_moveup(a,b,c) sat_memmove(a,b,c)
#define sat_movedown(a,b,c) sat_memmove(a,b,c)

int sat_getfreetempob();

int sat_createtemp(int objsize);

int sat_shrinklastob(int objaddr, int newsize);





BOOL sat_push_string(int type_prolog, int size_nibbles, const char *data);

unsigned int sat_map_s2a(unsigned int sat_addr);

unsigned int sat_map_a2s(unsigned int arm_addr);

#define sat_peek_sat_addr(sat_addr) sat_peek((sat_addr),5)

#define sat_peek_sat_byte(sat_addr) ((unsigned char) sat_peek((sat_addr),2))



void *sat_peek_sat_bytes(void *target, unsigned sat_addr, int nbytes);


unsigned char *sat_concatnib(unsigned char *dest, unsigned int destLen,
			     unsigned char *source,
			     unsigned int sourceLen);



#define sat_poke_sat_byte(sat_addr,val) sat_poke((sat_addr), (unsigned) (val), 2)

#define sat_poke_sat_bytes(sat_addr, bytes, n) sat_poke_nibbles((sat_addr), (bytes), (2*(n)))


#define sat_poke_sat_addr(sat_addr,val) sat_poke((sat_addr), (val), 5)


/* Saturn register save area */
/*
#define SAT_INTRPPTR 0x8076B
#define SAT_DSKTOP   0x806F8
#define SAT_RSKTOP   0x806F3
#define SAT_AVMEM    0x80E9B
#define SAT_TEMPTOP  0x806EE
#define SAT_EDITLINE  0x806FD
#define SAT_ERROR 0x80EA5
*/


/* OTHER USEFUL SATURN OBJECTS */
#define SAT_TRUE 0x3a81
#define SAT_FALSE 0x3ac0





/* RPL stack */

unsigned sat_stack_init();

void sat_stack_exit(unsigned rpl_stack_bias);

int sat_stack_depth();

int sat_get_stack_element(int index, SAT_STACK_ELEMENT * element);

int sat_stack_drop();

int sat_stack_dropn(int n);

int sat_stack_swap();

int sat_stack_nip();

/* push primitives */

int sat_stack_push_string(const char *str);


char *sat_pop_str(char *buf);

char *sat_pick_str(int level, char *buf);

char *sat_pick_str_alloc(int level);

char *sat_pop_str_alloc();

#define sat_stack_pop_string(s) sat_pop_str((s))

#define sat_stack_pop_string_alloc sat_pop_str_alloc

#define sat_stack_pick_string(l,b) sat_pick_str((l),(b))

#define sat_stack_pick_string_alloc(l) sat_pick_str_alloc((l))

int _sat_stack_push_int(int z, int radix, int binary);

int sat_stack_push_int(int z);

int sat_stack_push_double(double d);

int sat_push_zint_llong(unsigned long long num);


int sat_push_zint_array(unsigned int digits, unsigned int negative,
			 unsigned char *source);

LONGLONG sat_pop_zint_llong();

SAT_LIST sat_list_create(unsigned int maxSize);

void sat_list_destroy(SAT_LIST list);

BOOL sat_push_list(SAT_LIST list);

void sat_list_add_real(SAT_LIST list, double num);

void sat_list_add_zint_array(SAT_LIST list, unsigned int digits,
			     unsigned int negative, unsigned char *source);

char *sat_convert_zint_array(unsigned int digits, unsigned int negative,
			     unsigned char *source, unsigned char *dest);

void sat_list_add_zint(SAT_LIST list, LONGLONG num);

unsigned char *sat_convert_double_real(double number,
				       unsigned char *realStr);

int sat_stack_levels_avail();


/* Saturn data codec */

char *_sat_decode_string(unsigned sat_addr);

int sat_decode_stack_element(SAT_STACK_DATA * data,
			     SAT_STACK_ELEMENT * stack);

double sat_pop_real();


/* LOW-LEVEL ROUTINES FOR DIRECT OBJECT ACCESS */


void sat_pushptr(int sataddr);

BOOL sat_push_string(int type_prolog, int size_nibbles, const char *data);

BOOL sat_push_bint(int bint);

BOOL sat_push_real(double number);

BOOL sat_push_char(char byte);

BOOL sat_push_comp(ULONGLONG real, ULONGLONG imag);

BOOL sat_push_realarray(int rows, int columns, ULONGLONG * arry);


LONGLONG sat_BCD2LONGLONG(unsigned addr, int digits);
double sat_real2double(unsigned addr);
ULONGLONG sat_double2real(double n);
int sat_decode_real(unsigned address, double *val);


int sat_check_type(unsigned int level, unsigned int prologue);

int sat_stack_pop_stdargs(char ***argv);

int _sat_stack_pop_stdargs(const char *arg0, char ***argv);

void sat_errorsto(int errno);

void sat_pushtruefalse(BOOL arg);

#define sat_stack_push_bool sat_pushtruefalse


#endif
