#ifndef __BCD_UTILS_H
#define __BCD_UTILS_H	1

#include "decNumber.h"

/*  Memory allocation */

decNumber *bcd_alloc_number(int digits);
decNumber *bcd_alloc_add(decNumber * a, decNumber * b);
decNumber *bcd_alloc_sub(decNumber * a, decNumber * b);
decNumber *bcd_alloc_mul(decNumber * a, decNumber * b);

/*  Conversion  */

void bcd_get_coefficient(unsigned addr, int n_digits, decNumber * dn);
int bcd_set_maxdigits(int dig);
char *bcd_zerotrim_str(char *s);
int sat_bcd2decNumber(unsigned addr, decNumber ** dn);

/*  RPL Stack manipulation */

int sat_pick_bcd(int level, decNumber ** val);
int sat_pop_bcd(decNumber ** num);


/*  RPL directory access */

int sat_rcl_bcd(char *name, decNumber ** num);


#endif				/*  __BCD_UTILS_H */
