#define  DECNUMDIGITS 32	/*  work with up to 32 digits */

#include <hpgcc49.h>
#include "decNumber.h"		/*  base number library */
#include "bcdutils.h"


int sat_bcd2decNumber(unsigned addr, decNumber ** dn)
{

    int prolog = sat_peek(addr, 5);

    addr += 5;

    if (REAL_0 <= prolog && prolog <= REAL_9) {
	*dn = bcd_alloc_number(1);
	(*dn)->lsu[0] = (decNumberUnit) (prolog - REAL_0) / 21;

    }

    else if (prolog == SAT_DOREAL) {
	*dn = bcd_alloc_number(12);
	int expo = (int) sat_BCD2LONGLONG(addr, 3);
	if (expo > 499)
	    expo -= 1000;
	(*dn)->exponent = expo - 11;
	bcd_get_coefficient(addr + 3, 12, *dn);
	if ((int) sat_BCD2LONGLONG(addr + 15, 1) == 9)
	    (*dn)->bits |= DECNEG;

    } else
	return -1;		/*  ERROR */

    return 0;
}
