#define DONT_USE_HPGCC_LIBC
#include <hpgcc49.h>

#include "gglpr.h"

/*
 * 2007-11-08: portable version
 */

static void ggl_hblt1(unsigned char *dest, int destoff, unsigned char *src,
		      int srcoff)
{
    unsigned char *ptr, nibble;

    /* read nibble */
    ptr = (unsigned char *) src + (srcoff >> 1);
    if (srcoff & 1)
	nibble = (*ptr & 0x70) >> 4;
    else
	nibble = (*ptr & 0x07);

    /* write nibble */
    ptr = (unsigned char *) dest + (destoff >> 1);
    if (destoff & 1)
	*ptr = (*ptr & 0x07) | (nibble << 4);
    else
	*ptr = (*ptr & 0x70) | nibble;

    return;
}


/* COPIES npixels NIBBLES FROM src TO dest
 * dest AND src ARE WORD ALIGNED ADDRESSES
 * destoff AND srcoff ARE OFFSETS IN NIBBLES (PIXELS) FROM dest AND src
 */

void ggl_hblt(int *dest, int destoff, int *src, int srcoff, int npixels)
{
    while (npixels--) {
	ggl_hblt1((unsigned char *) dest, destoff,
		  (unsigned char *) src, srcoff);
	destoff++;
	srcoff++;
    }
    return;
}
