#include <hpgcc49.h>

#include "gglpr.h"

/*
 * 2007-11-08: portable version
 */

static void ggl_hblt1oper(unsigned char *dest, int destoff,
			  unsigned char *src, int srcoff, int param,
			  ggloperator foperator)
{
    unsigned char *ptr, nibble;

    /* read nibble */
    ptr = (unsigned char *) src + (srcoff >> 1);
    if (srcoff & 1)
	nibble = (*ptr & 0x70) >> 4;
    else
	nibble = (*ptr & 0x07);

    /* write nibble */
    ptr = (unsigned char *) dest + (destoff >> 1);
    if (destoff & 1)
	*ptr = (*ptr & 0x07) | (((*foperator)(*ptr, nibble, param) & 0x07) << 4);
    else
	*ptr = (*ptr & 0x70) | ((*foperator)(*ptr >> 4, nibble, param) & 0x07);

    return;
}


/*  SAME AS hblt BUT THIS ONE APPLIES AN ARBITRARY OPERATOR BETWEEN 2 SURFACES */
/*  COPIES npixels NIBBLES FROM src TO dest */
/*  dest AND src ARE WORD ALIGNED ADDRESSES */
/*  destoff AND srcoff ARE OFFSETS IN NIBBLES (PIXELS) FROM dest AND src */
/*  tcolor INDICATES WHICH OF THE 16 COLORS IS TRANSPARENT */
/*  RESTRICTIONS: */

/*     npixels<=512 (NO CHECKS MADE HERE) */


void ggl_hbltoper(int *dest, int destoff, int *src, int srcoff,
		  int npixels, int param, ggloperator foperator)
{
    while (npixels--) {
	ggl_hblt1oper((unsigned char *) dest, destoff,
		  (unsigned char *) src, srcoff, param, foperator);
	destoff++;
	srcoff++;
    }
    return;
}
