#include <stddef.h>
#include "hpgraphics.h"
#include "hpgpriv.h"

/* 
 * 2007-11-08: declaring *fb as unsigned char!
 */

unsigned char _hpg_mono_get(hpg_t * g, int x, int y)
{
    unsigned char *fb = (unsigned char *) g->drawfb + g->fbwidth * y + (x >> 3);
    int index = x & 7;
    if (*fb & (1 << index))
	return 0xFF;
    else
	return 0x00;
}

unsigned char _hpg_gray4_get(hpg_t * g, int x, int y)
{
    unsigned char *fb = (unsigned char *) g->drawfb + g->fbwidth * y + (x >> 2);
    int index = (x & 3) << 1;
    unsigned color = ((0x3 << index) & *fb) >> index;
    return color | (color << 2) | (color << 4) | (color << 6);
}

unsigned char _hpg_gray16_get(hpg_t * g, int x, int y)
{
    unsigned char *fb = (unsigned char *) g->drawfb + g->fbwidth * y + (x >> 1);
    unsigned char color;
    if (x & 1)
	color = *fb >> 4;
    else
	color = *fb & 0x0f;

    return color | (color << 4);
}
