#include <hpstdlib.h>
#include "hpgraphics.h"
#include "hpgpriv.h"


void _hpg_set_mode(int mode, char *visfb, char *drawfb,
		   void (*drawfn) (hpg_t *, int, int, int, int, int),
		   unsigned char (*getfn) (hpg_t *, int, int))
{
    char *orgvisfb = visfb;
    char *orgdrawfb = drawfb;
    char *finalbuffer;
    int linewidth;

    finalbuffer = visfb;
    drawfb = drawfb;

    linewidth = sys_lcdsetmode(mode, (int *) finalbuffer);


    /*
     * Update graphics context state so the library knows how to
     * deal with the current graphics mode.
     */

    if (hpg_stdscreen->fb != DEFAULT_PLANE) {
	free((char *) hpg_stdscreen->org_fb1);
    }

    if ((hpg_stdscreen->drawfb != DEFAULT_PLANE)
	&& (hpg_stdscreen->drawfb != hpg_stdscreen->fb)) {
	free((char *) hpg_stdscreen->org_fb2);
    }

    hpg_stdscreen->org_fb1 = orgvisfb;
    hpg_stdscreen->org_fb2 = orgdrawfb;
    hpg_stdscreen->fb = visfb;
    hpg_stdscreen->drawfb = drawfb;
    hpg_stdscreen->fbwidth = linewidth;
    hpg_stdscreen->drawfn = drawfn;
    hpg_stdscreen->getfn = getfn;
}
