#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_blit(hpg_t *src, int sx, int sy, int w, int h,
              hpg_t *dst, int dx, int dy)
{
    hpg_init();

    unsigned char saved_color = dst->color;

    int xoff = dx - sx;
    int yoff = dy - sy;

    int x, y;
    for (x = sx; x < sx + w; x++)
    {
        int tx = x + xoff;
        for (y = sy; y < sy + h; y++)
        {
            int ty = y + yoff;
            dst->color = hpg_get_pixel(src, x, y);
            hpg_draw_pixel_on(dst, tx, ty);
        }
    }

    dst->color = saved_color;
}
