#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_clip(hpg_t *g, int x1, int y1, int x2, int y2)
{
    hpg_init();

    g->clipx1 = max(x1, g->clipx1);
    g->clipy1 = max(y1, g->clipy1);
    g->clipx2 = min(x2, g->clipx2);
    g->clipy2 = min(y2, g->clipy2);
}

void hpg_clip_reset(hpg_t *g)
{
    hpg_init();

    g->clipx1 = g->clipy1 = 0;
    g->clipx2 = g->width;
    g->clipy2 = g->height;
}

void hpg_clip_set(hpg_t *g, int x1, int y1, int x2, int y2)
{
    hpg_init();

    if (x1 < 0) x1 = 0;
    if (y1 < 0) y1 = 0;
    if (x2 >= g->width) x2 = g->width - 1;
    if (y2 >= g->height) y2 = g->height - 1;

    g->clipx1 = x1;
    g->clipy1 = y1;
    g->clipx2 = x2;
    g->clipy2 = y2;
}
