#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_fill_rect(int x1, int y1, int x2, int y2)
{
    hpg_fill_rect_on(hpg_stdscreen, x1, y1, x2, y2);
}

void hpg_fill_rect_on(hpg_t *g, int x1, int y1, int x2, int y2)
{
    hpg_init();

    if (x1 > x2)
    {
        int temp;

        temp = x1;
        x1 = x2;
        x2 = temp;
    }

    int y;
    for (y = y1; y <= y2; y++)
    {
        _hpg_draw(g, x1, y, x2 - x1 + 1, x1, y1);
    }
}

void hpg_fill_circle(int cx, int cy, int r)
{
    hpg_fill_circle_on(hpg_stdscreen, cx, cy, r);
}


void hpg_fill_circle_on(hpg_t *g, int cx, int cy, int r)
{
    hpg_init();

    int x, y, d;

    d = 3 - (2 * r);
    x = 0;
    y = r;

    while (x <= y)
    {
        int px, py;
        px = x;
        py = y;

        if (d < 0)
        {
            d += 4 * x + 6;
        }
        else
        {
            d += 4 * (x - y) + 10;
            y--;
        }

        x++;

        if (y != py)
        {
            _hpg_draw(g, cx - px, cy + py, 2 * px + 1, cx - r, cy - r);
            _hpg_draw(g, cx - px, cy - py, 2 * px + 1, cx - r, cy - r);
        }

        if (px != py)
        {
            _hpg_draw(g, cx - py, cy + px, 2 * py + 1, cx - r, cy - r);
            if (px != 0)
            {
                _hpg_draw(g, cx - py, cy - px, 2 * py + 1, cx - r, cy - r);
            }
        }
    }
}

void hpg_fill_polygon(int vx[], int vy[], int len)
{
    hpg_fill_polygon_on(hpg_stdscreen, vx, vy, len);
}

void hpg_fill_polygon_on(hpg_t *g, int vx[], int vy[], int len)
{
    hpg_init();
    _hpg_poly(g, vx, vy, len, 1);
}
