#include <hpstdlib.h>
#include "hpgraphics.h"
#include "hpgpriv.h"

unsigned char hpg_get_color(hpg_t *g)
{
    hpg_init();
    return g->color;
}


hpg_font_t *hpg_get_font(hpg_t *g)
{
    hpg_init();

    if (g->font == NULL) g->font = hpg_get_minifont();
    return g->font;
}

int hpg_get_height(hpg_t *g)
{
    hpg_init();
    return g->height;
}

unsigned char hpg_get_mode(hpg_t *g)
{
    hpg_init();
    return g->mode;
}

hpg_pattern_t *hpg_get_pattern(hpg_t *g)
{
    hpg_init();
    return g->pattern;
}

unsigned char hpg_get_pixel(hpg_t *g, int x, int y)
{
    hpg_init();

    if ((x < 0) || (y < 0) || (x >= g->width) || (y >= g->height))
    {
        return HPG_COLOR_WHITE;
    }
    else
    {
        return (*g->getfn)(g, x, y);
    }
}

int hpg_get_width(hpg_t *g)
{
    hpg_init();
    return g->width;
}

int hpg_font_get_height(hpg_font_t *font)
{
    hpg_init();
    return font->height;
}

int hpg_font_get_advance(hpg_font_t *font)
{
    hpg_init();
    return font->advance;
}
