#include <hpstdlib.h>
#include <hpsys.h>
#include "hpgraphics.h"
#include "hpgpriv.h"

#include "../include/hpapine_gui.h"

/*
 * The graphics context representing the current screen.
 */
static hpg_t main_hpg;
static int inited = 0;

/*
 * The main pointer to the screen, initialized to the data structure above.
 */
hpg_t *hpg_stdscreen = &main_hpg;


/*
 * Initialization code for the screen
 */
void hpg_init(void)
{
    if (inited) return;

    gui_run();

    hpg_stdscreen = &main_hpg;

    main_hpg.fb = DEFAULT_PLANE;
    main_hpg.drawfb = DEFAULT_PLANE;
    main_hpg.width = SCR_WIDTH;

    /*  FIXED BY CLAUDIO - MULTIPLE CALC SUPPORT */
    main_hpg.height = sys_lcdgetheight();
    main_hpg.clipx1 = 0;
    main_hpg.clipy1 = 0;
    main_hpg.clipx2 = main_hpg.width;
    main_hpg.clipy2 = main_hpg.height;
    main_hpg.mode = HPG_MODE_PAINT;
    main_hpg.color = HPG_COLOR_BLACK;
    main_hpg.pattern = NULL;
    main_hpg.fbwidth = 0x14;
    main_hpg.drawfn = _hpg_mono_draw;
    main_hpg.getfn = _hpg_mono_get;

    inited = 1;
    atexit(hpg_cleanup);
}

void hpg_cleanup(void)
{
    if (!inited) return;

/* FIXME: testdoublebuf.c crash */
/*
    if (main_hpg.org_fb1 != DEFAULT_PLANE)
    {
        free(main_hpg.org_fb1);
    }

    if ((main_hpg.org_fb2 != DEFAULT_PLANE)
        && (main_hpg.org_fb2 != main_hpg.org_fb1))
    {
        free(main_hpg.org_fb2);
    }
*/
    inited = 0;
}
