#include <hpstdlib.h>
#include <hpstring.h>
#include "hpgraphics.h"
#include "hpgpriv.h"


hpg_t *hpg_load_xpm_mono(char *xpm[])
{
    hpg_init();

    struct hpg_xpm_info info = _hpg_get_xpm_info(xpm);

    hpg_t *img = hpg_alloc_mono_image(info.width, info.height);
    if (img == NULL) return NULL;

    _hpg_load_xpm(info, img, xpm);
    return img;
}

hpg_t *hpg_load_xpm_gray4(char *xpm[])
{
    hpg_init();

    struct hpg_xpm_info info = _hpg_get_xpm_info(xpm);

    hpg_t *img = hpg_alloc_gray4_image(info.width, info.height);
    if (img == NULL) return NULL;

    _hpg_load_xpm(info, img, xpm);
    return img;
}

hpg_t *hpg_load_xpm_gray16(char *xpm[])
{
    hpg_init();

    struct hpg_xpm_info info = _hpg_get_xpm_info(xpm);

    hpg_t *img = hpg_alloc_gray16_image(info.width, info.height);
    if (img == NULL) return NULL;

    _hpg_load_xpm(info, img, xpm);
    return img;
}
