#define LCD_W	160
#define LCD_H	 80
extern unsigned char _default_screen_buf[];
extern unsigned char *screen_buf;

#define DEFAULT_PLANE	((char *) & _default_screen_buf[0])

#define SCR_WIDTH 131
#define SCR_HEIGHT 80

#ifndef min
#define min(a, b) (((a) < (b)) ? (a) : (b))
#endif

#ifndef max
#define max(a, b) (((a) > (b)) ? (a) : (b))
#endif

struct hpg_graphics
{
    char *org_fb1,*org_fb2;
    char *fb;
    char *drawfb;
    void (*drawfn)(hpg_t *g, int x, int y, int len, int patx, int paty);
    unsigned char (*getfn)(hpg_t *g, int x, int y);
    unsigned int width, height;
    unsigned int fbwidth;
    unsigned int clipx1, clipy1, clipx2, clipy2;
    unsigned char mode;
    unsigned char color;
    hpg_pattern_t *pattern;
    hpg_font_t *font;
};

struct hpg_font
{
    char *buffer;
    unsigned int count;
    unsigned char height;
    unsigned char advance;
};

struct hpg_pattern
{
    char *buffer;
    unsigned char height;
    unsigned char fixed;
};

void _hpg_set_mode(int mode,char *visfb, char *drawfb,
    void (*drawfn)(hpg_t *, int, int, int, int, int),
    unsigned char (*getfn)(hpg_t *, int, int));

void _hpg_mono_draw(hpg_t *g, int x, int y, int len, int patx, int paty);
void _hpg_gray4_draw(hpg_t *g, int x, int y, int len, int patx, int paty);
void _hpg_gray16_draw(hpg_t *g, int x, int y, int len, int patx, int paty);
unsigned char _hpg_mono_get(hpg_t *g, int x, int y);
unsigned char _hpg_gray4_get(hpg_t *g, int x, int y);
unsigned char _hpg_gray16_get(hpg_t *g, int x, int y);
void _hpg_draw(hpg_t *g, int x, int y, int len, int patx, int paty);
void _hpg_poly(hpg_t *g, int vx[], int vy[], int len, int fill);

struct hpg_xpm_info
{
    int width, height;
    int ncolors;
    int cpp;
};

struct hpg_xpm_info _hpg_get_xpm_info(char *xpm[]);
void _hpg_load_xpm(struct hpg_xpm_info info, hpg_t *img, char *xpm[]);
