#include "hpmath.h"

        
double
gauss(void)
{
    static int have_next_gaussian = 0;
    static double next_gaussian;
    double s,v1,v2,mult;
    
    if (have_next_gaussian) {
        have_next_gaussian = 0;
        return next_gaussian;
    }
    
    s = 0.0;
    do {
        v1 = 2.0 * random() - 1.0;
        v2 = 2.0 * random() - 1.0;
        s  = v1*v1 + v2*v2;
    } while ( s >= 1.0 );
    mult = sqrt(-2.0 * log(s)/s);
    next_gaussian = mult * v2;
    have_next_gaussian = 1;
    
    return mult * v1;
}

double
normal(double mu, double sigma)
{
    return gauss()*sigma + mu;
}


