#include "hpmath.h"
    
double
newton(DFUNC1 f, double x0, double y)
{
    #define MAXTRIES 100
    #define EPSILON 1.0e-6

    double y0;
    int tries = 0;
    
    while (++tries < MAXTRIES && fabs(y0=(*f)(x0)-y) > EPSILON) 
        x0 -= y0/df(1,f,x0);

    return (tries < MAXTRIES)? x0 : MATH_ERR_NEWTON_INVALID;
}
