#include "hpstring.h"

/*
 * atoui()
 */

unsigned int atoui_base(char *buf, int base)
{
    int digit, base_1;
    char c;
    unsigned int val;

    base_1 = base - 1;

    val = 0;
    while ((c = *buf++)) {
	if (isdigit(c))
	    digit = c - '0';
	else if (isupper(c))
	    digit = c - 'A' + 10;
	else if (islower(c))
	    digit = c - 'a' + 10;
	else
	    break;

	if (digit < 0 || digit > base_1)
	    break;

	val = base * val + digit;
    }

    return val;
}

unsigned int atoui(char *buf)
{
    return atoui_base(buf, 10);
}


/*
 * atoull()
 */

unsigned long long atoull_base(char *buf, int base)
{
    int digit, base_1;
    char c;
    unsigned long long val;

    base_1 = base - 1;

    val = 0;
    while ((c = *buf++)) {
	if (isdigit(c))
	    digit = c - '0';
	else if (isupper(c))
	    digit = c - 'A' + 10;
	else if (islower(c))
	    digit = c - 'a' + 10;
	else
	    break;

	if (digit < 0 || digit > base_1)
	    break;

	val = base * val + digit;
    }

    return val;
}


unsigned long long atoull(char *buf)
{
    return atoull_base(buf, 10);
}
