#include "hpstring.h"
#include <stdlib.h>


char *lower(char *t, const char *s)
{
    char *r = t;
    while (*s)
	*t++ = tolower(*s++);
    *t = '\0';
    return r;
}


char *upper(char *t, const char *s)
{
    char *r = t;
    while (*s)
	*t++ = toupper(*s++);
    *t = '\0';
    return r;
}


char *str_unquote(char *s, char c)
{
    if (*s == c) {
	char *p = (char *) (s + strlen(s) - 1);
	if (*p == c && p > s) {
	    *p = '\0';
	    s++;
	}
    }

    return s;
}


char *strset(char *s, int fill)
{
    char *t = s;
    while (*s)
	*s++ = fill > 0 ? (char) fill : 'a' + rand() % 26;
    return t;
}


char *xpad(char *t, char *s, int n, int left, char c)
{
    char buf[n + 1];
    int slen;

    if ((slen = strlen(s)) >= n)
	return strcpy(t, s);

    memset(buf, c, n);
    buf[n] = '\0';

    if (left)
	strcpy((char *) (buf + n - slen), s);
    else
	strncpy(buf, s, slen);


    return strcpy(t, buf);


}
