#define DONT_USE_HPGCC_LIBC
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "saturn.h"
#include "rplapi.h"
#include "dirapi.h"
#include "../include/_hpapine_version.h"	/* hpapine_print_version() */


rpl_t_DIR *__home = NULL;
rpl_t_DIR *__context = NULL;

static void _print_atexit(void);
static void _home_print(void);


static void _print_atexit(void)
{
    static int init = 0;
    if (init)
	return;
    atexit(_home_print);
    init = 1;
}

void _home_init(void)
{
    if (__home)
	return;
    hpapine_print_version();

    char *fn;
    FILE *f;
    rpl_t_OBJ *pdir, *ppath;

    fn = getenv("HPAPINE_HOME");
    if (!fn)
	fn = "HOME";

    fprintf(stderr, "--- Reading HOME contents from %s...\n", fn);
    f = fopen(fn, "r");
    if (!f) {
	perror(fn);
	fprintf(stderr, "Setting HOME to empty directoy.\n");
	pdir = rpl_new_dir();
	__home = (rpl_t_DIR *) pdir->ptr;
	if (!__home) {
	    perror(__FUNCTION__);
	    exit(1);
	}
	__context = __home;
    } else {
	pdir = rpl_fread_dir(f);
	if (! pdir) {
	    fprintf(stderr, "Setting HOME to empty directoy.\n");
	    pdir = rpl_new_dir();
	}
	ppath = rpl_fread_list(f);
	fclose(f);

	__home = (rpl_t_DIR *) pdir->ptr;
	__context = __home;	/* FIXME */
    }

    _print_atexit();
}


static void _home_print(void)
{
    char *fn;
    FILE *f;
    rpl_t_OBJ home;

    home.prolog = SAT_DORRP;
    home.ptr = __home;

    fn = "HOME.out";
    f = fopen(fn, "w");
    if (!f) {
	perror(fn);
	fprintf(stderr, "--- Printing HOME to stderr:\n");
	f = stderr;
    }

    rpl_fprint_obj(f, &home);

    if (f != stderr)
	fclose(f);
}
