#include <hpgcc49.h>

/*
This is a helper function for the Saturn domain. Basically, its like strcat, but works on binary strings
of Saturn data.

It itaks in a destination (dest), and the current dest size in nibbles (destLen)
source is a binary string to add to dest, and sourceLen is the number of nibbles
to add. It returns a pointer to the destination.

-Al, 18 Feb '05

*/

unsigned char *sat_concatnib(unsigned char *dest, unsigned int destLen,
			     unsigned char *source, unsigned int sourceLen)
{

    int i;

    if ((destLen % 2) == 0) {
	for (i = 0; i <= sourceLen / 2; i++)
	    dest[i + destLen / 2] = source[i];
    }
    else {	/* odd number of nibbles, so need to shift */

	/* I really, really hate the Saturn.  */
	/* Well, I love it. -- kdntl, 2007-11-10. */

	/* take care of first nibble */
	dest[destLen / 2] = (dest[destLen / 2] & 0x0f) | (source[0] << 4);	

	for (i = 1; i <= sourceLen / 2; i++) {
	    dest[i + destLen / 2] =
		((source[i - 1]) >> 4) | (source[i] << 4);
	}
    }

    return dest;
}
