#include <stdlib.h>
#include <string.h>
#include "saturn.h"
#include "rplapi.h"

double sat_pop_real(void)
{
    rpl_t_OBJ *pobj = rpl_stack_pop();
    if (!pobj)
	return 0.0;

    if (pobj->prolog != SAT_DOREAL)
	return 0.0;

    return *((double *) pobj->ptr);
}

char *sat_pop_str_alloc(void)
{
    rpl_t_OBJ *pobj = rpl_stack_pop();
    if (!pobj)
	return NULL;

    if (pobj->prolog != SAT_DOCSTR)
	return NULL;

    return *((char **) pobj->ptr);
}


char *sat_pop_str(char *buf)
{
    char *s = sat_pop_str_alloc();
    if (!s) {
	*buf = '\0';
	return NULL;
    }

    strcpy(buf, s);
    free(s);
    return buf;
}



int ___sat_get_nibble(char *data, int nibble)
{
    if (nibble & 1) {		/* nibble is odd */
	return (data[nibble / 2] >> 4) & 0xf;
    }

    return (data[nibble / 2]) & 0xf;
}

void ___read_sat_mem(int source, char *dest, int bytes)
{
    int i = 0;
    for (i = 0; i < bytes; i++) {
	dest[i] = sat_peek(source + i * 2, 2);
    }
}


LONGLONG sat_pop_zint_llong(void)
{
    if (sat_stack_depth == 0)
	return 0;

    LONGLONG num = 0;

    SAT_STACK_ELEMENT e;
    sat_get_stack_element(1, &e);

    if (e.prologue != SAT_DOINT)
	return 0;

    unsigned int zintSize = (sat_peek(e.addr + 5, 8) & 0xfffff) - 5;
    unsigned char data[zintSize / 2 + 50];
    ___read_sat_mem(e.addr + 10, data, zintSize / 2 + 1);

    unsigned int i = zintSize - 1;

    while (i != 0) {
	i--;
	num = num * 10 + ___sat_get_nibble(data, i);
    }

    if (___sat_get_nibble(data, zintSize - 1) == 9) {
	num = 0 - num;
    }
    sat_stack_drop();
    return num;
}
