#include <hpgcc49.h>





double
sat_real2double (unsigned address)
{
    #define MAX_IEEE754_EXPO 307
    
    int expo;
    double val;
        
    expo = (int) sat_BCD2LONGLONG (address, 3);
    
    if (expo > 499)
        expo -= 1000;
    
    /*  Check for IEEE-754 exponent over/underflow... */
    
    if (expo > MAX_IEEE754_EXPO)
        expo = MAX_IEEE754_EXPO;
    
    else if(expo < -MAX_IEEE754_EXPO) 
        /*  Treat this number as zero... */
        return 0.0;

    /*  val =  sat_BCD2LONGLONG (address + 3, 12)) * ipow(10.0,expo-11); // mantissa */

	/*  REPLACED IPOW(10,X) BY I10POWX(X) - CLAUDIO MAR 2006 */

    val =  (LONGLONG)(1000 * sat_BCD2LONGLONG (address + 3, 12)) * i10powx(expo-14); /* mantissa */
    
    return  (int) sat_BCD2LONGLONG (address + 15, 1) /* sign */ == 9 ? -val : val;
}



