#include <hpgcc49.h>





#define STBL(prolog,size) (prolog + (size << 20))

#define SAT_TOTALOBJECTS 34

/*  TABLE TO SKIP OBJECTS */
unsigned int __skipobtbl[SAT_TOTALOBJECTS]={

/*  FIXED-SIZE OBJECTS */
    STBL(SAT_DOBINT,10),
    STBL(SAT_DOREAL,21),
    STBL(SAT_DOEREL,26),
    STBL(SAT_DOCMP,37),
    STBL(SAT_DOECMP,47),
    STBL(SAT_DOCHAR,7),
    STBL(SAT_DOROMP,11),
    STBL(SAT_DOFLASHP,12),

/*  LIST-LIKE OBJECTS */
    STBL(SAT_DOLIST,0xFF),
    STBL(SAT_DOCOL,0xFF),
    STBL(SAT_DOEXT,0xFF),
    STBL(SAT_DOMATRIX,0xFF),
    STBL(SAT_DOSYMB,0xFF),

/*  IDNT-LIKE OBJECTS */
    STBL(SAT_DOIDNT,0xFE),
    STBL(SAT_DOLAM,0xFE),

/*  SIZE-SKIPPABLE */
    STBL(SAT_DOARRY,0xFD),
    STBL(SAT_DOBAK,0xFD),
    STBL(SAT_DOCODE,0xFD),
    STBL(SAT_DOCSTR,0xFD),
    STBL(SAT_DOGROB,0xFD),
    STBL(SAT_DOHXS,0xFD),
    STBL(SAT_DOINT,0xFD),
    STBL(SAT_DOLNKARRY,0xFD),
    STBL(SAT_DOLIB,0xFD),
    STBL(SAT_DOEXT0,0xFD),
    STBL(SAT_DOEXT1,0xFD),        /*  COULD BE WRONG - ACPTR IS PROBABLY A FIXED-SIZE OBJECT */
    STBL(SAT_DOEXT2,0xFD),
    STBL(SAT_DOEXT3,0xFD),
    STBL(SAT_DOEXT4,0xFD),
    STBL(SAT_DOLNGCOMP,0xFD),  /*  PROBABLY FIXED SIZE, BUT APPARENTLY UNUSED? */
    STBL(SAT_DOLNGREAL,0xFD),  /*  PROBABLY FIXED SIZE, BUT APPARENTLY UNUSED? */
    STBL(SAT_DOAPLET,0xFD),    /*  MIGHT BE WRONG */

/*  SPECIAL OBJECTS */
    STBL(SAT_DORRP,0xFC),
    STBL(SAT_DOTAG,0xFB)
};



int 
sat_skipob(int obaddr)
{
    unsigned int *tbl = __skipobtbl;
    unsigned int f,prolog,value;
    int item;

    prolog=sat_peek(obaddr,5);

    for(f=0;f<SAT_TOTALOBJECTS;++f)
    
        if( ((value=tbl[f])&0xfffff)==prolog ) {
    
            value>>=20;
            switch(value)
            {
            case 0xfb:
                /*  DOTAG OBJECTS */
                return sat_skipob( sat_sknameup(obaddr+5)-2);
    
            case 0xfc:
                /*  DIRECTORIES */
                obaddr=sat_objgetdir(obaddr);
                item=sat_dirfindfirst(obaddr);
                if(item<0) return obaddr+5;
                return sat_skipob(sat_sknameup(item));
    
            case 0xfd:
                /*  SIZE-SKIPPABLE OBJECTS */
                obaddr+=5;
                return obaddr+sat_peek(obaddr,5);
    
            case 0xfe:
                /*  IDNT-LIKE OBJECTS */
                obaddr+=5;
                return obaddr+((sat_peek(obaddr,2)+1)<<1);
    
            case 0xff:
                /*  LIST-LIKE OBJECTS */
                obaddr+=5;
                while(sat_peek(obaddr,5)!=SAT_SEMI)
                {
                    obaddr=sat_skipob(obaddr);
                }
                return obaddr+5;
    
            default:
                return obaddr+value;
            }
        }
    

    /*  SKIP ROM POINTERS */
    return obaddr+5;

}


