#define DONT_USE_HPGCC_LIBC
#include <saturn.h>
#include <hpstring.h>
#include <hpsys.h>
#include "rplapi.h"
#include <stdlib.h>
#include <string.h>


unsigned sat_stack_init(void)
{
   return 0;
}

void sat_stack_exit(unsigned stack_bias)
{
  return;
}

int sat_stack_depth(void)
{
    return rpl_stack_depth();
}

int sat_stack_levels_avail(void)
{
    return _ram_size*2 / 5;
}

int sat_get_stack_element(int index, SAT_STACK_ELEMENT * p)
{
    p->addr = p->prologue = 0;

    int d = sat_stack_depth();
    if (index <= 0 || index > d)
        return -1;

    p->addr = * ((int *) rpl_stack.data[d-index].ptr);
    p->prologue = rpl_stack.data[d-index].prolog;
    return 0;
}


int sat_stack_drop(void)
{
    return rpl_stack_drop();
}

int sat_stack_dropn(int n)
{
   return rpl_stack_dropn(n);
}

int sat_stack_swap()
{
   int d = rpl_stack_depth();
   if (d <= 1)
     return 0;

   rpl_t_OBJ tmp = rpl_stack.data[d-1];
   rpl_stack.data[d-1] = rpl_stack.data[d-2];
   rpl_stack.data[d-2] = tmp;
   return 1;
}

int sat_stack_nip(void)
{
    if (sat_stack_swap())
	return sat_stack_drop();
    else
	return 0;
}


int _sat_stack_pop_stdargs(const char *arg0, char ***argv)
{
    char **_argv;
    int arg_start = 0;
    int argc = sat_stack_depth();

    if (arg0) {
	argc++;
	arg_start = 1;
    }

    if (argc) {
	_argv = (char **) sys_chkptr(calloc(argc, sizeof(char *)));
	int i;

	for (i = argc - 1; i >= arg_start; i--) {
	    char *ss = sat_pop_str_alloc();
	    _argv[i] = ss? str_unquote(ss, '\'') : "";
	}

	if (arg_start)
	    _argv[0] = (char *) arg0;

	*argv = _argv;
    }

    return argc;
}

int sat_stack_pop_stdargs(char ***argv)
{
    return _sat_stack_pop_stdargs(NULL, argv);
}



int sat_stack_push_double(double d)
{
/*
    rpl_stack_push(rpl_new_real(d));
    return sizeof(double);
*/
    char buf[32];
    sprintf(buf, "%f", d);
    return sat_stack_push_string(buf);
}


int _sat_stack_push_int(int z, int radix, int binary)
{
    char zz[16];
    char buf[32];
    char *a = NULL;

    itoa(z, zz, radix);
    if (binary && (radix == 8 || radix == 10 || radix == 16)) {
	strcpy(buf, "#");
	strcat(buf, zz);
	switch (radix) {
	case 8:
	    a = "o";
	    break;
	case 10:
	    a = "d";
	    break;
	case 16:
	    a = "h";
	    break;
	}
	strcat(buf, a);
    }

    return sat_stack_push_string(a ? buf : zz);
}

int sat_stack_push_int(int z)
{
    return _sat_stack_push_int(z, 10, 0);
}

int sat_stack_push_string(const char *sdata)
{
    if (!sdata)
	return 0;
    rpl_stack_push(rpl_new_cstr(sdata));
    return strlen(sdata);
}


