#include <saturn.h>

void sat_stoZintAli(unsigned int digits, unsigned int negative,
		    char *source, char *dest)
{
/* even number of digits */
    unsigned int numBytes = digits / 2;	/* aligned */
    if (negative) {
	dest[numBytes] = 0x09;	/*  make negative */
    } else {
	dest[numBytes] = 0x00;	/*  make positive     */
    }


    unsigned int i = 0;
    while (numBytes > 0) {	/* now pack ZINT */
	numBytes--;
	dest[numBytes] = (source[2 * i] << 4) | (source[2 * i + 1]);
	i++;
    }

    return;

}


void sat_stoZintNAli(unsigned int digits, unsigned int negative,
		     char *source, char *dest)
{
/* odd number of digits */
    unsigned int byteCount = digits / 2;	/* not aligned */

    dest[byteCount] = source[0];	/*   */

    if (negative) {
	dest[byteCount] = dest[byteCount] | 0x90;	/*  make negative */
    }

    unsigned int i = 1;
    while (byteCount > 0) {	/* now pack ZINT */
	byteCount--;
	dest[byteCount] = (source[2 * i - 1] << 4) | (source[2 * i]);
	i++;
    }

    return;
}

char *sat_convert_zint_array(unsigned int digits, unsigned int negative,
			     unsigned char *source, unsigned char *dest)
{
    /* prologue */
    dest[0] = 0x14;
    dest[1] = 0x26;
    dest[2] = 0x00;

    unsigned int size = digits + 5 + 1;	/* account for size field and sign nibble */

    dest[2] = (size & 0xf) << 4;	/* lowest nibble of size  */
    dest[3] = size >> 4;	/* next 2 nibbles */
    dest[4] = size >> 12;	/* final 2 nibbles */


    char encodedZint[(digits / 2) + 5];

    if (digits & 1) {		/* odd number of digits */
	sat_stoZintNAli(digits, negative, (char *) source, encodedZint);
    } else {			/* even number */
	sat_stoZintAli(digits, negative, (char *) source, encodedZint);
    }

    sat_concatnib(dest, 10, (unsigned char *) encodedZint, digits + 1);	/* concat */
    return (char *) dest;
}
