#include "hpkeyb49.h"

int keyb_isKeyPressed(unsigned char col, unsigned char row)
{
    return keyb_isKeyPrM(col * 8 + row + 1);
}

int keyb_isKeyPrM(int keycode)
{
    keymatrix m;
    keyb_getmatrix(&m);

    return (m.full & (1LL << keycode)) ? 1 : 0;
}

int keyb_isShiftKeyPrM(int shiftcode)
{
    keymatrix m;
    keyb_getmatrix(&m);

    /* The key is down */
    if ((m.full & (1LL << KEYCODE(shiftcode))) == 0)
	return 0;

    if ((SHFTPLANE(shiftcode) == SHFT_ANY)
	&& (m.full & (KB_ALPHA | KB_LSHIFT | KB_RSHIFT | KB_ON)))
	return 1;

    if (SHFTPLANE(shiftcode) & (m.full >> 32))
	return 1;

    return 0;
}


int keyb_isAnyKeyPressed(void)
{
    keymatrix m;
    keyb_getmatrix(&m);

    if (m.full)
	return 1;
    else
	return 0;
}



int keyb_isUp(void)
{
    return keyb_isKeyPrM(KB_UP);
}

int keyb_isDown(void)
{
    return keyb_isKeyPrM(KB_DN);
}

int keyb_isLeft(void)
{
    return keyb_isKeyPrM(KB_LF);
}

int keyb_isRight(void)
{
    return keyb_isKeyPrM(KB_RT);
}

int keyb_isRS(void)
{
    return keyb_isKeyPrM(KB_RSHIFT);
}

int keyb_isLS(void)
{
    return keyb_isKeyPrM(KB_LSHIFT);
}

int keyb_isAlpha(void)
{
    return keyb_isKeyPrM(KB_ALPHA);
}

int keyb_isON(void)
{
    return keyb_isKeyPrM(KB_ON);
}
