#include "../include/hpapine_gui.h"
#include <hpsys.h>
#include <hpscreen.h>
#include <kos.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>


#define LCD_W	160	/* but the physical LCD's width is 131px */
#define LCD_H	 80

static int screen_mode = MODE_MONO;

unsigned char _default_screen_buf[LCD_W * LCD_H >> 1];
unsigned char *screen_buf = _default_screen_buf;


char *getLCDPointer(int x, int y)
{
    gui_run();
    return (char *) screen_buf + (LCD_W >> 3) * y + (x >> 3);
}

int screen_getpixlum(int x, int y)
{
    unsigned char *ptr;
    unsigned char ali;
    unsigned char res;

    if (screen_mode == MODE_MONO) {
        ptr = screen_buf + (LCD_W >> 3) * y + (x >> 3);
	ali = x & 0x07;
	res = (*ptr & (0x01 << ali)) ? 0xf : 0x0;
    }
    else if (screen_mode == MODE_4GRAY) {
        ptr = screen_buf + (LCD_W >> 2) * y + (x >> 2);
	ali = x & 0x03;
	res = (*ptr & (0x03 << (ali << 1))) >> (ali << 1) << 2;
    }
    else if (screen_mode == MODE_16GRAY) {
        ptr = screen_buf + (LCD_W >> 1) * y + (x >> 1);
	ali = x & 1;
	if (ali)
	  res = *ptr >> 4;
	else
	  res = *ptr & 0x0f;
    }
    else
	  res = 0;

    return 0xf - (res & 0x0f);
}

/*
 * clear screen routines
 */

static void screen_clear(void)
{
    gui_run();
    memset(screen_buf, 0, LCD_W * LCD_H >> (3 - screen_mode));
}

void kos_ClearLcd(void)
{
    screen_clear();
}

void clearScreen(void)
{
    screen_clear();
}

/*
 * Hardware related routines
 */

int sys_lcdsetmode(int mode, int *physbuf)
{
    gui_run();

    screen_mode = mode;
    gui_change_screenbuf((unsigned char *) physbuf);

    return LCD_W >> (3 - mode);
}



/*
 * kos_PutString
 */

U32 kos_PutString(U32 dx, U32 dy, P_VOID ptr)
{
    print((char *) ptr, dx, dy);
    return 0;
}


void kos_PutHexNumber(U32 dx, U32 dy, U32 value)
{
    char s[11];			/* a 32-bit integer takes at most 10 chars */
    snprintf(s, 11, "%x", value);
    kos_PutString(dx, dy, s);
    return;
}

/* FIXME: what is bit? */
void kos_PutDecNumber(U32 dx, U32 dy, U32 value, U32 bit)
{
    char s[10];			/* a 32-bit integer takes at most 9 chars */
    snprintf(s, 10, "%u", value);
    kos_PutString(dx, dy, s);
    return;
}
