#include "hpsys.h"
#include <stdlib.h>
#include <stdio.h>


void sys_error(const char *msg, int code)
{
    if (msg) {
	fprintf(stderr, "%s\n", msg);
    }
    if (code < 0) {
	exit(-code);
    }
}

void *sys_chkptr(void *p)
{
    if (p == NULL)
	sys_error("NULL pointer!", -1);
    return p;
}
	

int sys_map_v2p(unsigned int vaddr)
{
    return vaddr;
}

int sys_map_p2v(unsigned int paddr)
{
    return paddr;
}


int sys_mem_classify(int addr)
{
    int r, a = (addr >> 16) & 0xf;

    /*  0 OR 1 --> SYSTEM MEMORY */
    /*  2 OR 3 --> PORT1 */
    /*  4 THRU 7 --> MAIN RAM */

    if (a < 2)
	r = 0;
    else if (a > 3)
	r = 2;
    else
	r = 1;

    return r;
}


void
*sys_phys_malloc(size_t size)
{
    return malloc(size);
}
