#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>

#include "hptime.h"
#include "hpsys.h"


void sys_tm_RTC(struct tm *t)
{
    time_t now = time(NULL);
    struct tm *lt = localtime(&now);

    t->tm_sec = lt->tm_sec;
    t->tm_min = lt->tm_min;
    t->tm_hour = lt->tm_hour;
    t->tm_mday = lt->tm_mday;
    t->tm_mon = lt->tm_mon;
    t->tm_year = lt->tm_year;
    t->tm_wday = lt->tm_wday;
    t->tm_isdst = lt->tm_isdst;
}


int sys_RTC_seconds(void)
{
    return (int) time(NULL);
}


int _sys_RTCTickPeriod = 15;

unsigned char sys_setRTCTickPeriod(unsigned char n)
{
    if (n == 0 || n > 127)
	return _sys_RTCTickPeriod;

    _sys_RTCTickPeriod = n;

    return 0;
}

void sys_waitRTCTicks(int count)
{
    float wait = count * (_sys_RTCTickPeriod + 1.);	/* in 1/128 s */
    usleep((unsigned long) (1e6 * wait / 128.));
}

void sys_waitTicks(unsigned int time)
{
    usleep((unsigned long) (1e6 * time / 750e3));
}

int sys_isRTCTick(void)
{
    struct timeval tv;
    unsigned int t128;

    gettimeofday(&tv, NULL);


    /* We take a modulo here to get a smaller integer.
     * That doesn't change the final result.
     */
    t128 = (tv.tv_sec % (_sys_RTCTickPeriod + 1)) * 128;
    t128 += (tv.tv_usec * 128 / 1e6);
    
    return (t128 % (_sys_RTCTickPeriod + 1)) == 0;
}


unsigned short int sys_getPWMCounter0(void)
{
    struct timeval tv;
    unsigned int t;

    gettimeofday(&tv, NULL);

    t = tv.tv_usec * 0xffff / 1e6;

    return (unsigned short) t;
}


/*
 * timer
 */

void sys_setupTimers(void)
{
    fprintf(stderr, "%s: not yet implemented\n", __FUNCTION__);
    return;
}

void sys_restoreTimers()
{
    fprintf(stderr, "%s: not yet implemented\n", __FUNCTION__);
}


ULONGLONG sys_updateTimer(sys_timer_t * timer)
{
    fprintf(stderr, "%s: not yet implemented\n", __FUNCTION__);
    return 0;
}


/*
 *
 */

void sys_sleep(unsigned int duration)
{
    usleep(duration);
}

int sys_delta_seconds(int t_start, int t_end)
{
    int delta_t = t_end - t_start;

    return delta_t >= 0 ? delta_t : delta_t + 3600 * 24;
}
