

// GLOBALS GENERATED BY 'LD'
extern unsigned int __data_start,__data_size,__bss_size;

// GLOBALS GENERATED TO BE USED BY _start

extern unsigned int _code_base,_ram_base,_heap_start;
extern unsigned int _saturn_cpu;


// _start DECLARATION
extern int _start();
extern void _init_globals(int sat_cpu,int rsize,int cbase,int hbase,int nentries);

void __c_loader();

// PURE "C" FUNCTION START
// DECLARE THIS FUNCTION HERE SO IT WILL BE THE FIRST FUNCTION IN THE .text SECTION
void __c_loader()
{
    
    
    register unsigned int *new_bss_base, *ram_ptr,*org_data;
    register unsigned int data_size,bss_size;
    register int f,nitems;
    register int sat_cpu asm("r1");

//  READ NON-GLOBAL VARIABLES CREATED BY 'ld'
    org_data=(unsigned int *)&__data_start;
    data_size=(unsigned int)&__data_size;
    bss_size=(unsigned int)&__bss_size;

    ram_ptr=(unsigned int *)0x01101000;    // FIXED DATA SEGMENT START

    new_bss_base=(unsigned int *)((unsigned int) ram_ptr  + data_size);


//  MOVE .data SECTION TO RAM

    nitems=(data_size+3)>>2;

    for(f=0;f<nitems;++f) ram_ptr[f]=org_data[f];


//  INITIALIZE .bss SECTION TO 0

    nitems=(bss_size+3)>>2;
    for(f=0;f<nitems;++f) new_bss_base[f]=0;


//  DONE! GLOBALS ARE WORKING FROM HERE ON!

_init_globals(sat_cpu,(*( (unsigned int *) (sat_cpu+0x914))-4)<<10,0x01220000,(unsigned int)new_bss_base+bss_size,*( (unsigned int *) (sat_cpu+0x914))>>2);



// RAM DATA STRUCTURE IS:
// _ram_base: (virtual address = 0x01101000
// .rodata SECTION (W/CONSTANTS EMBEDDED IN CODE, MOVED TO RAM)
// .data SECTION
// .bss SECTION    
// _heap_start:
// ...free memory...

// stack

}




// ASSEMBLER SETUP

void _loader() __attribute__ ((naked));
void _loader()
{


asm ("stmfd sp!,{r0-r12,lr}");

    // DISABLE IRQs (ibl)
/*
    asm("mov r7, #0x7100000");        
    asm("add r7,r7, #0x8"); 
    asm("mov r6, #0xFFFFFFFF");
    asm("str r6, [r7]");
*/

// MOVE DATA TO NEW MEMORY
    __c_loader();

// ALL GLOBALS WORKING FROM HERE ON...

    _start();

    // ENABLE IRQs (ibl)
/*
    asm("mov r7, #0x7100000"); 
    asm("add r7,r7, #0x8");
    asm("ldr r6, =0xbdff9346");
    asm("str r6, [r7]");
*/

asm ("ldmfd sp!,{r0-r12,pc}");

}
