@echo off

REM HP-GCC Parameters




REM =====================
REM Please enter the path to the HPGCC libs (.a files) and includes (.h files)

set hpgcc_libs=%HPGCC%\lib
set hpgcc_includes= %HPGCC%\include
set hpgcc_linkscript=%HPGCC%\lib

REM =====================
REM change this value to alter the amount of ram 
REM set aside for pushing to the RPL stack

set hpgcc_rplstacksize=10000

REM This limits the size of the objects you can push
REM the default is 10kb, which should let you push 10kb worth of objects.

REM ====================

REM change this value to alter the amount of ram 
REM set aside for pushing pointers to the RPL Stack
REM Multiply the number below by 5 to determine the 
REM number of objects you can push

set hpgcc_rplstackdepth=1

REM this limits the number of objects you may push
REM the default is 1, which will let you push 5 objects.



REM primitive error checking
if (%1)==() goto USAGE
if (%1)==(/?) goto USAGE
if (%1)==(-h) goto USAGE
if (%1)==(-help) goto USAGE
if (%1)==(--help) goto USAGE

REM cleanup
set hpgcc_out=
set hpgcc_src=
set hpgcc_obj=

REM read in all the parameters
set hpgcc_out=%1
:PARSEINPUT
set hpgcc_src=%hpgcc_src% %1.c
set hpgcc_obj=%hpgcc_obj% %1.o
shift
if not (%1)==() goto PARSEINPUT

echo ********************
echo HP-GCC DOS Front-End
echo ********************
echo If sucessful, '%hpgcc_out%.hp' is your program.

REM do the compilation
@echo on
arm-elf-gcc -nostdlib -mapcs-32 -fpic -msingle-pic-base -mpic-register=r10 -msoft-float -mlittle-endian -O3  -fomit-frame-pointer -mtune=arm920t -I %hpgcc_includes% -c %hpgcc_src%

arm-elf-ld -T %hpgcc_linkscript%\mmuld.script -nodefaultlibs -nostdlib -static %hpgcc_obj% %hpgcc_libs%\crt0.o -L %hpgcc_libs% -lwin -lggl -lhpg -lhplib -lgcc -o %hpgcc_out%.bin

elf2hp %hpgcc_out%.bin %hpgcc_out%.hp -s%hpgcc_rplstacksize% -d%hpgcc_rplstackdepth% 

@echo off

REM cleanup
rem del %hpgcc_obj%
rem del %hpgcc_out%.bin
set hpgcc_out=
set hpgcc_src=
set hpgcc_obj=

goto END
REM usage
:USAGE
echo Compile C source files for the HP49G+/48Gii
echo Usage: hpgcc filename1 filename2 ... filenameN
echo Output: filename1.hp (to be run by the ARM Toolbox)
echo Note: Do not include the .c extension in the file names
echo .
echo If you get a heap of "bad command or file name"
echo errors, make sure that you have the HPGCC variable set
echo to your HP-GCC binaries folder (typically c:\arm-hp\bin)
echo Do not include a trailing slash!
REM done
:END
@echo on
