//& ****************************************************************************
//&
//& Written by Claudio Lapilli, Mar 2006
//& Copyright (C) 2004 The HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************


#include <hpmath.h>

// CALCULATE 10^X WITH 64-BIT PRECISION
// RETURN A BASE-2 EXPONENT + A 64-BIT MANTISSA
// MORE ACCURATE THAN STANDARD POW AND IPOW

int _i10pow64(int exp10,unsigned long long *mant)
{
unsigned long long val=0x8000000000000000LL;
int exp2=-63;

while(exp10>=3) {
val=val-(((val>>1)+(val>>2)+16)>>5);
exp10-=3;
exp2+=10;
if(!(val&0x8000000000000000LL)) { val<<=1; exp2--; }
}

while(exp10>0) {
val=val-(((val>>1)+(val>>2)+1)>>1);
exp10--;
exp2+=4;
if(!(val&0x8000000000000000LL)) { val<<=1; exp2--; }
}


*mant=val;
return exp2;
}

