//& ****************************************************************************
//&
//& Written by Claudio Lapilli, Mar 2006
//& Copyright (C) 2004 The HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************


#include <hpmath.h>


// RETURNS A DOUBLE GIVEN A NORMALIZED 64-BIT MANTISSA, BASE-2 EXPONENT AND SIGN

double assemble_double(unsigned int sign,unsigned long long mantissa,int exponent)
{
	union {
		struct { unsigned int fill32bits; double a; };
		struct { unsigned long long ul; unsigned int repeatword; };
	} dbl;
	if(sign) sign=0x800;
	dbl.ul=((mantissa<<1)+0x800)>>12;
	dbl.ul|=((unsigned long long)(((exponent+1023+63)&0x7ff)|sign))<<52;
	
	// FAST WORKAROUND FOR THE BIG-ENDIAN DOUBLE REPRESENTATION IN GCC
	dbl.repeatword=(unsigned int)dbl.fill32bits;
	return dbl.a;

}

