//& ****************************************************************************
//&
//& Written by Ingo Blank
//& Copyright (C) 2004,2005 Ingo Blank
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

// $Header: /cvsroot/hpgcc/sources/hplib/math/dround.c,v 1.6 2005/07/09 16:06:45 iblank Exp $

#include <hpgcc49.h>

double
dround(double v, int d)
{
		// REPLACED IPOW(10,X) BY I10POWX(X) - CLAUDIO MAR 2006

    double scale = 1.0, expo = i10powx(abs(d));
    int minus,expo2,iexp;
    
    if ((minus = v < 0.0))
        v = -v;
    
    frexp(v,&expo2);
    iexp = (int) (expo2*M_LN2/M_LN10);
    
    if (iexp < 0)
			// REPLACED IPOW(10,X) BY I10POWX(X) - CLAUDIO MAR 2006

        v *= (scale = i10powx(-iexp));
    
    v = (round(v * expo ) / expo) / scale;
    //v = ((double) (((ULONGLONG) (v * expo + .5))/expo))/scale;

    return minus ? -v : v;
}


