//& <prolog>
//& ****************************************************************************
//&
//& Written by Ingo Blank & Claudio Lapilli
//&
//& Copyright (C) 2005 HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

//& </prolog>

// $Header: /cvsroot/hpgcc/sources/hplib/saturn/sat_dir_close.c,v 1.3 2005/05/18 19:27:25 iblank Exp $

#include <hpgcc49.h>





/*!
    \fn        void sat_dir_close(SAT_DIR_NODE *p)
    \brief    Close (destroy) the internal data structures
            May be called explicitly, to recover memory.
*/

void
_sat_dir_close(SAT_DIR_NODE *p)
{
    while (p) {
        
        SAT_DIR_ENTRY *q = p->object;
        
        while(q) {
            SAT_DIR_ENTRY *u = q->next; 
            free(q->sat_obj->name);
            free(q->sat_obj);
            free(q);
            q = u;
        }
        
        SAT_DIR_NODE *v = p->sibling;    
        
        free(p->name);
        _sat_dir_close(p->child);
        free(p);
        
        p = v;
    }
}

void
sat_dir_close()
{
    if(__sat_root) {
        _sat_dir_close(__sat_root);
        __sat_root = __sat_cwd = NULL;
    }
}


