//& <prolog>
//& ****************************************************************************
//&
//& Written by Ingo Blank & Claudio Lapilli
//&
//& Copyright (C) 2005 HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

//& </prolog>

// $Header: /cvsroot/hpgcc/sources/hplib/saturn/sat_dir_path.c,v 1.3 2005/05/18 19:27:25 iblank Exp $

#include <hpgcc49.h>





/*!
    \fn char *_sat_dir_path(SAT_DIR_NODE *P)
    \brief return a string representation of the path leading to node P
*/

char
*_sat_dir_path(SAT_DIR_NODE *P)
{
    #define _PATHLEN 256
    
    SAT_DIR_NODE *p = _sat_dir_getroot(), *q = P;
    char *path,*s,*t;
    int slen;
        
    sys_chkptr(path = calloc(_PATHLEN,sizeof(char)));
    s = (char *)((unsigned long) path + _PATHLEN - 1);    
    while (p != q) {
        slen = strlen(q->name);
        s = (char *)((unsigned long) s - slen -1);
        *s = '/';
        strncpy((char *)((unsigned long)s+1),q->name,slen);
        q = q->parent;
    }
    
    t = "HOME";
    slen = strlen(t);
    s = (char *)((unsigned long) s - slen);
    strncpy(s,t,slen);
    t = strdup(s);
    free(path);
    
    return t;
    
}



