//& <prolog>
//& ****************************************************************************
//&
//& Written by Al Borowski
//&
//& Copyright (C) 2005 HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

//& </prolog>

// $Header: /cvsroot/hpgcc/sources/hplib/saturn/sat_real2double.c,v 1.2 2005/05/19 09:01:58 iblank Exp $

#include <hpgcc49.h>

//Pops a real from the stack, as a double. Returns 0.0 on error.
//First revision Al Borowski 22nd Jan '05. 
// Heavily mutilated by Claudio - Mar 2006

double sat_pop_real()

{
double number;


    if(sat_stack_depth()==0){
            return 0.0; //error: too few arguments
    }

    SAT_STACK_ELEMENT e; //   Get element at level #1, i.e. stack-top
    sat_get_stack_element(1,&e);
    
    if (e.prologue!=SAT_DOREAL){
        return 0.0; //error: not a real
    }

	// REMOVED ALL CONVERSION CODE BY AL BOROWSKI, NOW USING THE MORE ACCURATE
	// sat_real2double()
	number=sat_real2double(e.addr+5);		
	
    sat_stack_drop(); //pop the real from the stack
    return number;

}

