//& <prolog>
//& ****************************************************************************
//&
//& Written by Ingo Blank & Claudio Lapilli
//&
//& Copyright (C) 2005 HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

//& </prolog>

// $Header: /cvsroot/hpgcc/sources/hplib/saturn/sat_real2double.c,v 1.2 2005/05/19 09:01:58 iblank Exp $

#include <hpgcc49.h>





double
sat_real2double (unsigned address)
{
    #define MAX_IEEE754_EXPO 307
    
    int expo;
    double val;
        
    expo = (int) sat_BCD2LONGLONG (address, 3);
    
    if (expo > 499)
        expo -= 1000;
    
    // Check for IEEE-754 exponent over/underflow...
    
    if (expo > MAX_IEEE754_EXPO)
        expo = MAX_IEEE754_EXPO;
    
    else if(expo < -MAX_IEEE754_EXPO) 
        // Treat this number as zero...
        return 0.0;

    // val =  sat_BCD2LONGLONG (address + 3, 12)) * ipow(10.0,expo-11); /* mantissa */

	// REPLACED IPOW(10,X) BY I10POWX(X) - CLAUDIO MAR 2006

    val =  (LONGLONG)(1000 * sat_BCD2LONGLONG (address + 3, 12)) * i10powx(expo-14); /* mantissa */
    
    return  (int) sat_BCD2LONGLONG (address + 15, 1) /* sign */ == 9 ? -val : val;
}



