//& ****************************************************************************
//&
//& Written by Ingo Blank
//& Copyright (C) 2004,2005 Ingo Blank
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************


// $Header: /cvsroot/hpgcc/sources/hplib/strings/atof.c,v 1.6 2005/07/10 00:12:08 iblank Exp $

#include <hpstring.h>
#include <hpmath.h>


double
atof(const char * _buf)
{
    
    double val,expo;
    int minus,fraction_digits;
    ULONGLONG integral,ifraction;
    char c,__buf[32],*buf;
    
    buf = lower(__buf,_buf); // just handle lowercase chars
    
    integral = ifraction = 0;
    fraction_digits = 0;
    val = 0.0;
    expo = 1.0;
    
    if((minus = (*buf == '-')))
        buf++;
    if (*buf == '+')
        buf++;
        
    while (*buf && *buf != '.') {
        c = *buf++;
        if (isdigit(c))
            integral = 10 * integral + c - '0';
        else {
            
            if (c == 'e') {
                buf--;
                goto parse_expo;
            }
            goto finish;
        }
    }
    
    
    if (*buf == '.') {
        buf++;
        while (*buf && *buf != 'e' ) {
            c = *buf++;
            if (! isdigit(c)) goto finish;
            fraction_digits++;
            ifraction = 10 * ifraction + c - '0';
        }
    }
    
parse_expo:
    
    if (*buf == 'e') {
        int expo_minus,ee = 0;
        buf++;
        if ((expo_minus = (*buf == '-')))
            buf++;
        if (*buf == '+')
            buf++;
        while (*buf) {
            c = *buf++;
            if (! isdigit(c))
                goto finish;
            ee = 10 * ee + c - '0';
        }
		// REPLACED IPOW(10,X) BY I10POWX(X) - CLAUDIO MAR 2006
		
        expo = i10powx(expo_minus ? -ee : ee);
    }

finish:
	// REPLACED IPOW(10,X) BY I10POWX(X) - CLAUDIO MAR 2006

    val = expo * ((double) integral + (double) ifraction / i10powx(fraction_digits));
    return minus ? -val : val;
}
