//& ****************************************************************************
//&
//& Copyright (C) 2004,2005 The HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************


// $Header: /cvsroot/hpgcc/sources/hplib/sys/bsearch.c,v 1.1 2005/05/08 11:36:11 iblank Exp $

#include <hpstdlib.h>


void *
bsearch(register const void *key, register const void *base,
    register size_t n_elements, register size_t size,
    int (*compar)(const void *, const void *))
{
    register const void *mid;
    register int  cmp;

    while (n_elements > 0) {
        mid = (char *)base + size * (n_elements >> 1);
        if ((cmp = (*compar)(key, mid)) == 0)
            return (void *)mid;
        if (cmp >= 0) {
            base  = (char *)mid + size;
            n_elements = (n_elements - 1) >> 1;
        } else
            n_elements >>= 1;
    }
    return (void *) NULL;
}
