//& ****************************************************************************
//&
//& Written by HPGCC Team
//& 
//& Copyright (C) 2004 The HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

// $Header: /cvsroot/hpgcc/sources/hplib/sys/sys_error.c,v 1.4 2005/05/22 16:21:21 njz3 Exp $

#include <hpsys.h>
#include <hpstdlib.h>
#include <hpstdio.h>
#include <hpkeyb49.h>


//extern int errno;

// < ibl ; 2005-02-08 >

/**
 *    Provide a standardized and centralized entry point for a unified error
 *     handling mechanism.
 *    
 *    To be continued ...
 *    
 **/

void
sys_error(const char *msg, int code)
{
    if(msg) {
        puts("");
        puts(msg);
    }
    if(( /*errno = */ code ) < 0) {
        // fatal, exit ...
        puts("Press ON to exit");
        while (! keyb_isON());
        exit(code);
    }
}

