//& ****************************************************************************
//&
//& Written by Ingo Blank, August 2004
//& 
//& Copyright (C) 2004,2005 Ingo Blank, HP-GCC Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************



// $Header: /cvsroot/hpgcc/sources/hplib/sys/sys_tm_RTC.c,v 1.3 2005/06/24 20:32:45 iblank Exp $



#include <hptime.h>
#include <hpsys.h>

void
sys_tm_RTC(struct tm *t)
{
    t->tm_sec     = sys_bcd2bin(*(unsigned char*)(RTC_REGS+0x70));
    t->tm_min     = sys_bcd2bin(*(unsigned char*)(RTC_REGS+0x74)) ;
    t->tm_hour = sys_bcd2bin(*(unsigned char*)(RTC_REGS+0x78));
    t->tm_mday = sys_bcd2bin(*(unsigned char*)(RTC_REGS+0x7C));
    t->tm_mon    = sys_bcd2bin(*(unsigned char*)(RTC_REGS+0x84)) - 1;
    t->tm_year = sys_bcd2bin(*(unsigned char*)(RTC_REGS+0x88)) + 100; 
    //printf("DEBUG: RTC(DOW)=%d\n",*((unsigned char*)(RTC_REGS+0x80)));
    t->tm_wday = (*((unsigned char*)(RTC_REGS+0x80)) & 7) - 1;  // [0..6] DOESN'T WORK !!!
    t->tm_isdst = -1;
    
}



