//do not edit this file

// definition of kernel functions
#ifndef __SYSCALL_H
#define __SYSCALL_H
#include <kos.h>

/*#define U32 unsigned int
#define S32 signed int*/


// define syscall entry 000-099
#define ReserveForTaskScheduler 0
#define ResetEntry              1
#define ScheduleTaskEntry       10
#define CreateMutexEntry        11
#define SystemPowerManagerEntry 12
#define LCDGetContrastEntry     13
#define TaskPowerOffEntry       14

#define CheckBatteryEntry       16
#define GetDisplayBufferEntry   17
#define GetKeyFocusEntry        18

#define DeviceSdInitEntry       19
#define GetUsbConnectStatusEntry    20
#define GetSDConnectStatusEntry     21

#define GetLastErrorEntry         22
#define LcdGetLineEntry         23
#define GetSysTickTimeEntry     24
#define GetCurrentTaskEntry        25

#define ClearLcdEntry            26
#define GetSerialEntry            27

#define    CheckBeepEndEntry        28
#define    StopBeepEntry            29
#define    GetCPUSpeed                30

// define syscall entry 100-199
#define freeEntry               101
#define KillTaskEntry           102
#define GetTaskPriorityEntry    103
#define SuspendTaskEntry        104
#define ResumeTaskEntry         105
#define WakeupTaskEntry         106
#define RemoveMutexEntry        107
#define ReleaseMutexEntry       108
#define CheckMutexEntry         109
#define RemoveSemaphoreEntry    110
#define ReleaseSemaphoreEntry   111
#define CheckSemaphoreEntry     112
#define RemoveEventEntry        113
#define SetEventEntry           114
#define ClearEventEntry         115
#define PulseEventEntry         116
#define CheckEventEntry         117
#define GetMessageEntry         118
#define PeekMessageEntry        119
#define SetTimerEntry           120
#define ClearTimerEntry         121
#define SetAlarmEntry           122
#define ClearAlarmEntry         123

#define closeEntry              124
#define GetRTCTimeEntry         125
#define SetRTCTimeEntry         126
#define LCDSetContrastEntry     127
#define SetKeyFocusEntry        128
#define PutKeyEntry             129
#define GetKeyMatrixEntry       130
#define SetLastErrorEntry        131
#define ReadSpecialTimerCountEntry  132
#define StartSpecialTimerEntry  133
#define StopSpecialTimerEntry   134
#define SelfTestEntry           135
#define DevicePowerOffEntry     136
#define DevicePowerOnEntry      137

#define KeyMessageMatrixEntry   138

//lcd refresh interrupt entry
#define LcdRefreshEntry           139
#define LcdRefreshSwitchEntry    140

// define syscall entry 200-299
#define mallocEntry             201
#define SetTaskPriorityEntry    202
#define DelayTaskEntry          203
#define CreateSemaphoreEntry    204
#define CreateEventEntry        205
#define WaitEventSetEntry       206
#define SendMessageEntry        207
#define PostMessageEntry        208

#define openEntry               209

#define SetSpecialTimerHandleEntry  211
#define SetSpecialTimerCountEntry   212

#define DeviceSdReadSectorEntry 213
#define DeviceSdWriteSectorEntry 214

#define SystemPowerOffEntry     215
#define CheckMemEntry           216

#define controlEntry            217

#define GetFuncEntry            218
#define SetCPUFreqEntry         219

// define syscall entry 300-399
#define GetMutexEntry           301
#define GetSemaphoreEntry       302

#define beepEntry               305

#define PutStringEntry            306
#define PutHexNumberEntry        307

// define syscall entry 400-499
#define CreateTaskEntry         401

#define readEntry               402
#define writeEntry              403
#define PutDecNumberEntry        404
#define Num2StringEntry            405

// define syscall entry 500-599

// define syscall entry 600-699

// define syscall entry 700-799


// sys call functions

U32 SysCall(U32 index);
U32 syscallArg0(U32 index);
U32 syscallArg1(U32 index, U32 arg1);
U32 syscallArg2(U32 index, U32 arg1, U32 arg2);
U32 syscallArg3(U32 index, U32 arg1, U32 arg2, U32 arg3);
U32 syscallArg4(U32 index, U32 arg1, U32 arg2, U32 arg3, U32 arg4);
U32 syscallArg5(U32 index, U32 arg1, U32 arg2, U32 arg3, U32 arg4, U32 arg5);
U32 syscallArg6(U32 index, U32 arg1, U32 arg2, U32 arg3, U32 arg4, U32 arg5, U32 arg6);
U32 syscallArg7(U32 index, U32 arg1, U32 arg2, U32 arg3, U32 arg4, U32 arg5, U32 arg6, U32 arg7);

#endif
