#include <hpgcc49.h>
#include <hpgbmp.h>
#include "hpgpriv.h"

int hpg_save_bmp_gray16 (char *name, palette_t pal[])
{
	int Ret = 0;
	FILE *file;

	// Opens the bitmap file
	if (file = fopen (name, "wb"))
	{
		char *type = "BM";
		int size = 5558;
		int dummy = 0;
		int headersize = 118;
		int headerinfo = 40;
		int width = 132;
		int height = 80;
		unsigned short planes = 1;
		unsigned short bits = 4;
		int resol = 5905;
		unsigned short shortdummy = 0;
		
		// Writes the header
		(void) fwrite ((void *)type, 1, 2, file);
		(void) fwrite ((void *)&size, 1, 4, file);
		(void) fwrite ((void *)&dummy, 1, 4, file);
		(void) fwrite ((void *)&headersize, 1, 4, file);
		
		(void) fwrite ((void *)&headerinfo, 1, 4, file);
		(void) fwrite ((void *)&width, 1, 4, file);
		(void) fwrite ((void *)&height, 1, 4, file);
		(void) fwrite ((void *)&planes, 1, 2, file);
		(void) fwrite ((void *)&bits, 1, 2, file);
		(void) fwrite ((void *)&dummy, 1, 4, file);
		(void) fwrite ((void *)&dummy, 1, 4, file);
		(void) fwrite ((void *)&resol, 1, 4, file);
		(void) fwrite ((void *)&resol, 1, 4, file);
		(void) fwrite ((void *)&dummy, 1, 4, file);
		(void) fwrite ((void *)&dummy, 1, 4, file);

		// If there is no provided palette as parameter, build one (levels of gray)
		if (! pal)
		{
			pal = (palette_t *) malloc (16 * sizeof (palette_t));
			int Ind;
					
			for (Ind = 0; Ind < 16; Ind++)
			{
				pal[15 - Ind].rgb[0] = Ind * 16 + Ind;
				pal[15 - Ind].rgb[1] = Ind * 16 + Ind;
				pal[15 - Ind].rgb[2] = Ind * 16 + Ind;
				pal[15 - Ind].rgb[3] = 0;
			}
		}
		
		// Writes the palette
		if (fwrite ((void *) pal, 1, 16 * sizeof(palette_t), file) == 16 * sizeof(palette_t))
		{	
			int x, y;
			unsigned char color = 0;
			int shift = 0;

			// Writes the file line by line (starting from the end), column by column
			for (y = 79; y >= 0; y--)
			{
				for (x = 0; x < 132; x++)
				{
					// Gets the pixel from the hpg_stdscreen
					unsigned char c = (hpg_get_pixel (hpg_stdscreen, x, y)) & 0x0F;
					// Gets the color
					color |= (shift ? c : (c << 4));
					// Writes the color (since we generate a 4 bits coded color, 2 pixels
					// must be stored at once, that's explain the 'shift' mechanism)
					if (shift)
					{
						(void) fwrite ((void *) &color, 1, 1, file);
						color = 0;
					}
					shift = (shift + 1) % 2;
				}
				
				// Fills the end of line for alignment
				(void) fwrite ((void *)&shortdummy, 1, 2, file);
			}
		}
		else
		{
			Ret = C_ErrWritePalette;
		}
					
		(void) fclose (file);
	}
	else
	{
		Ret = C_ErrOpenFile;
	}				
	
	return (Ret);
}

