#include <hpgcc49.h>
#include <hpparser.h>
#include "prspriv.h"

int prs_alg_get_element (entry_t *stack, int level, element_t *elem)
{
	int Ret = PRS_OK;

	if (stack && (level > 0) && (level < stack[0].data.Size) && elem)
	{
		switch (elem->Type = stack[level].Type)
		{
			case C_TypeVal :
			{
				elem->data.Val = stack[level].data.Val;
				break;
			}

			case C_TypeFunc :
			{
				elem->data.Func = stack[level].data.Func;
				break;
			}

			case C_TypeIdent :
			{
				elem->data.Ident = stack[level].data.Var->Name;
				break;
			}

			case C_TypeSymb :
			{
				elem->data.Symb = stack[level].data.Symb;
				break;
			}
		}
	}
	else
	{
		Ret = PRS_ERROR_PAR;
	}

	return (Ret);
}
