#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_code_int (LONGLONG val, unsigned *address)
{
	int Ret = HPS_OK;

	if (address)
	{
		int size = 0;

		if ((Ret = hps_objsize_type (DOINT, (void *) &val, &size)) == HPS_OK)
		{
			unsigned addr;
			
			if (addr = (*address ? *address : (*address = sat_createtemp (size))))
			{
				int sign = (val < 0) ? 9 : 0;						// Sign
	
				// Fills the prologue
				sat_poke (addr, DOINT, 5);
							
				// Fills the size
				sat_poke (addr + 5, size - 5, 5);				// Object size - prologue size
							
				// Fills the digits
				val = abs(val);
				val2BCD (val, addr + 10, size - 11, 10);		// Object size - prologue size - size size - sign size
					
				// Fills the sign
				sat_poke (addr + size - 1, sign, 1);
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
