#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_decode_ident (unsigned address, hpobj_t *obj, int *incr)
{
	int Ret = HPS_OK;
	unsigned prolog;
	
	if (obj && incr)
	{
		if (obj->type)
		{
			prolog = obj->type;							// There is no prologue (used by DOARRY)
			*incr = 0;
		}
		else
		{
			prolog = sat_peek (address, 5);
			address += 5;									// Skips the prologue
			*incr = 5;
		}
			
		switch (prolog)
		{
			case DOIDNT :
			{
				int len, l;
				unsigned addr = address;
				char *ident = NULL;
				
				// Gets the length of the ident
				l = len = sat_peek (addr, 2);
				addr += 2;
				
				// Allocs the string
				ident = obj->data.doidnt = (char *) malloc (len + 1);
				if (ident)
				{
					char *p = ident;
					while (l--)
					{
						*p = (char) sat_peek (addr, 2);
						p++;
						addr += 2;
					}
					*p = '\0';
				}
				else
				{
					Ret = HPS_ERROR_ARM_MEMORY;
				}
				
				obj->type = DOIDNT;
				*incr += len * 2 + 2;					// 2 nibbles per character + length
				
				break;
			}
			
			default :
			{
				Ret = HPS_ERROR_TYPE;
				break;
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
