#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_decode_list (unsigned address, hpobj_t *obj, int *incr)
{
	int Ret = HPS_OK;
	unsigned prolog;
	
	if (obj && incr)
	{
		if (obj->type)
		{
			prolog = obj->type;							// There is no prologue (used by DOARRY)
			*incr = 0;
		}
		else
		{
			prolog = sat_peek (address, 5);
			address += 5;									// Skips the prologue
			*incr = 5;
		}
			
		switch (prolog)
		{
			case DOLIST :
			{
				list_t *list = NULL;
				unsigned addr = address;
				unsigned prologue;
				
				// Creates the list
				if ((Ret = hps_list_create (&list)) == HPS_OK)
				{
					// Loops over the list until the end
					while ((prologue = sat_peek (addr, 5)) != SEMI)
					{
						hpobj_t *elem = NULL;
							
						if ((Ret = hps_obj_create (&elem)) == HPS_OK)
						{
							int delta;
								
							elem->type = 0;
							if ((Ret = hps_decode (addr, elem, &delta)) == HPS_OK)
							{
								if ((Ret = hps_list_add (list, elem)) != HPS_OK)
								{
									break;
								}
							}
							else
							{
								break;
							}
							addr += delta;
						}
						else
						{
							break;
						}
					}
					
					obj->data.dolist = list;
					obj->type = DOLIST;
					*incr += addr + 5 - address;		// Address after SEMI - address after prologue
				}
					
				break;
			}
			
			default :
			{
				Ret = HPS_ERROR_TYPE;
				break;
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
