#include <hpgcc49.h>
#include <hpstack.h>

int main (void)
{
	int ret;					// Return code for called functions

	// Picks an array at the top of the stack
	array_t *array;
	
	if ((ret = hps_pick_array (1, &array)) == HPS_OK)
	{
		// Gets the element [2, 4]
		hpobj_t *obj;
		
		if ((ret = hps_array_get (array, &obj, 2, 2, 4)) == HPS_OK)
		{
			// Pushes it onto the stack
			ret = hps_push (obj);
			(void) hps_obj_destroy (&obj);
		}
		else
		{
			ret = hps_push_str (hps_error (ret));
		}

		// Frees the allocated objects
		hps_array_destroy (&array);
	}
	if (ret != HPS_OK)
	{
		hps_push_str (hps_error (ret));
	}
		
	return (0);
}

