#include <hpgcc49.h>

int progress(int, int, int, int);
int bar(int, int, int);
int intlog10(double);

int main(int argc, char *argv[])
{
	int i;
	double num;
	FILE *fp;
	int p=0, lp=0, li=0;
	char errormsg[40], *filename="marbles.txt";

	if((fp = fopen(filename,"w")) == NULL) {
		sprintf(errormsg,"Cannot open: %s",filename);
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return(0);
	}

	num = sat_pop_real();
	if(num < 1) {
		sat_push_zint_llong((int) num);
		sat_stack_push_string("Number of marbles must be > 0");
		sat_push_real(1);
		return(0);
	}

	sys_slowOff();

	for(i=0;i<num;i++) {
		double x, y;

		x = gauss();
		y = gauss();
		fprintf(fp,"%0.6f %0.6f\n",x,y);

		if(num > 300) {
			p = ((i+1)*100)/num;
			if(p > lp && i > (li + 50)) {
				lp = p;
				li = i;
				progress(22,37,11,p);
			}
		}
		if(keyb_isAnyKeyPressed())
			break;
	}
	if(num > 300)
		progress(22,37,11,100);

	fclose(fp);
	sat_push_real(0);
	sys_waitRTCTicks(1);
	sys_slowOn();
	return(0);
}

int progress(int x, int y, int length, int p)
{
	unsigned char b[] = {0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01};
	int l = length * 8 - 2;
	int i;
	char t[4];
	static int shadow = 0;

	if(shadow == 0) {
		shadow = 1;
		bar(x+1,y+1,length);
	}

	bar(x,y,length);

	if(p < 0)
		return(0);

	if(p > 100)
		p = 100;

	sprintf(t,"%d%%",p);
	print(t,131 - x*2 - 25 - 2*intlog10(p),y+4);

	if(p == 0)
		return(0);

	for(i=0;i<(l*p)/100;i++) {
		drawBlockXOR(b,11,x+i+1,y+1);
	}

	return(0);
}

int bar(int x, int y, int length)
{
	unsigned char b[] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
	unsigned char r[] = {0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F};
	unsigned char m[] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
	unsigned char l[] = {0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE};
	int i;

	for(i=0;i<length;i++) {
		drawBlockOR(b,13,x+i*8,y);

		if(i == 0)
			drawBlockXOR(l,11,x+i*8,y+1);
		else if(i == length-1)
			drawBlockXOR(r,11,x+i*8,y+1);
		else
			drawBlockXOR(m,11,x+i*8,y+1);
	}

	return(0);
}

int intlog10(double x)
{
	int y=0;

	x++;
	while((x /= 10) > 1)
		y++;

	return(y);
}
