1     	#include <hpgcc49.h>
2     	
3     	int progress(int, int, int, int);
4     	int bar(int, int, int);
5     	int intlog10(double);
6     	
7     	int main(int argc, char *argv[])
8     	{
9     	    int i;
10    	    double num;
11    	    FILE *fp;
12    	    int p=0, lp=0, li=0;
13    	    char errormsg[40], *filename="marbles.txt";
14    	
15    	    if((fp = fopen(filename,"w")) == NULL) {
16    	        sprintf(errormsg,"Cannot open: %s",filename);
17    	        sat_stack_push_string(errormsg);
18    	        sat_push_real(1);
19    	        return(0);
20    	    }
21    	
22    	    num = sat_pop_real();
23    	    if(num < 1) {
24    	        sat_push_zint_llong((int) num);
25    	        sat_stack_push_string("Number of marbles must be > 0");
26    	        sat_push_real(1);
27    	        return(0);
28    	    }
29    	
30    	    sys_slowOff();
31    	
32    	    for(i=0;i<num;i++) {
33    	        double x, y;
34    	
35    	        x = gauss();
36    	        y = gauss();
37    	        fprintf(fp,"%0.6f %0.6f\n",x,y);
38    	
39    	        if(num > 300) {
40    	            p = ((i+1)*100)/num;
41    	            if(p > lp && i > (li + 50)) {
42    	                lp = p;
43    	                li = i;
44    	                progress(22,37,11,p);
45    	            }
46    	        }
47    	        if(keyb_isAnyKeyPressed())
48    	            break;
49    	    }
50    	    if(num > 300)
51    	        progress(22,37,11,100);
52    	
53    	    fclose(fp);
54    	    sat_push_real(0);
55    	    sys_waitRTCTicks(1);
56    	    sys_slowOn();
57    	    return(0);
58    	}
59    	
60    	int progress(int x, int y, int length, int p)
61    	{
62    	    unsigned char b[] = {0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01};
63    	    int l = length * 8 - 2;
64    	    int i;
65    	    char t[4];
66    	    static int shadow = 0;
67    	
68    	    if(shadow == 0) {
69    	        shadow = 1;
70    	        bar(x+1,y+1,length);
71    	    }
72    	
73    	    bar(x,y,length);
74    	
75    	    if(p < 0)
76    	        return(0);
77    	
78    	    if(p > 100)
79    	        p = 100;
80    	
81    	    sprintf(t,"%d%%",p);
82    	    print(t,131 - x*2 - 25 - 2*intlog10(p),y+4);
83    	
84    	    if(p == 0)
85    	        return(0);
86    	
87    	    for(i=0;i<(l*p)/100;i++) {
88    	        drawBlockXOR(b,11,x+i+1,y+1);
89    	    }
90    	
91    	    return(0);
92    	}
93    	
94    	int bar(int x, int y, int length)
95    	{
96    	    unsigned char b[] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
97    	    unsigned char r[] = {0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F};
98    	    unsigned char m[] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
99    	    unsigned char l[] = {0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE};
100   	    int i;
101   	
102   	    for(i=0;i<length;i++) {
103   	        drawBlockOR(b,13,x+i*8,y);
104   	
105   	        if(i == 0)
106   	            drawBlockXOR(l,11,x+i*8,y+1);
107   	        else if(i == length-1)
108   	            drawBlockXOR(r,11,x+i*8,y+1);
109   	        else
110   	            drawBlockXOR(m,11,x+i*8,y+1);
111   	    }
112   	
113   	    return(0);
114   	}
115   	
116   	int intlog10(double x)
117   	{
118   	    int y=0;
119   	
120   	    x++;
121   	    while((x /= 10) > 1)
122   	        y++;
123   	
124   	    return(y);
125   	}
