#include <hpgcc49.h>
#include <hpstack.h>

int main (void)
{
	list_t *se, *t = NULL;
	SAT_STACK_ELEMENT e;
	SAT_STACK_DATA d;
	int index=1;
	double x, y;
	char *filename, errormsg[40];
	FILE *fp;

	sat_get_stack_element(1,&e);
	sat_decode_stack_element(&d,&e);

	if (d.type == SAT_DATA_TYPE_STRING) {
		filename = str_unquote(d.sval,'\'');
		sat_stack_drop();
	}
	else {
		sat_stack_push_string("Missing Filename");
		sat_push_real(1);
		return(0);
	}

	if (hps_pop_list(&t) != HPS_OK) {
		sat_stack_push_string("List of points missing");
		sat_push_real(1);
		return(0);
	}

	if((fp = fopen(filename,"w")) == NULL) {
		sprintf(errormsg,"Cannot open: %s",filename);
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return(0);
	}

	sys_slowOff();

	while(hps_list_get_list(t ,index++ ,&se) == HPS_OK) {
		hps_list_get_real(se, 1, &x);
		hps_list_get_real(se, 2, &y);

		fprintf(fp,"%0.6f %0.6f\n",x,y);
	}

	fclose(fp);
	sat_push_real(0);
	sys_slowOn();
	return (0);
}


