1     	#include <hpgcc49.h>
2     	#include <hpstack.h>
3     	
4     	int main (void)
5     	{
6     	    list_t *se, *t = NULL;
7     	    SAT_STACK_ELEMENT e;
8     	    SAT_STACK_DATA d;
9     	    int index=1;
10    	    double x, y;
11    	    char *filename, errormsg[40];
12    	    FILE *fp;
13    	
14    	    sat_get_stack_element(1,&e);
15    	    sat_decode_stack_element(&d,&e);
16    	
17    	    if (d.type == SAT_DATA_TYPE_STRING) {
18    	        filename = str_unquote(d.sval,'\'');
19    	        sat_stack_drop();
20    	    }
21    	    else {
22    	        sat_stack_push_string("Missing Filename");
23    	        sat_push_real(1);
24    	        return(0);
25    	    }
26    	
27    	    if (hps_pop_list(&t) != HPS_OK) {
28    	        sat_stack_push_string("List of points missing");
29    	        sat_push_real(1);
30    	        return(0);
31    	    }
32    	
33    	    if((fp = fopen(filename,"w")) == NULL) {
34    	        sprintf(errormsg,"Cannot open: %s",filename);
35    	        sat_stack_push_string(errormsg);
36    	        sat_push_real(1);
37    	        return(0);
38    	    }
39    	
40    	    sys_slowOff();
41    	
42    	    while(hps_list_get_list(t ,index++ ,&se) == HPS_OK) {
43    	        hps_list_get_real(se, 1, &x);
44    	        hps_list_get_real(se, 2, &y);
45    	
46    	        fprintf(fp,"%0.6f %0.6f\n",x,y);
47    	    }
48    	
49    	    fclose(fp);
50    	    sat_push_real(0);
51    	    sys_slowOn();
52    	    return (0);
53    	}
54    	
55    	
