#include <hpgcc49.h>

#define RAND ((float) rand() / (float) 0x7fffffff)

int main()
{
	float x, y;
	int i;
	double num;
	SAT_STACK_ELEMENT e;
	SAT_STACK_DATA d;
	char *filename, errormsg[40];
	FILE *fp;

	sat_get_stack_element(1, &e);
	sat_decode_stack_element(&d, &e);

	if(d.type == SAT_DATA_TYPE_STRING) {
		filename = str_unquote(d.sval, '\'');
		sat_stack_drop();
	} else {
		sat_stack_push_string("Missing Filename");
		sat_push_real(1);
		return (0);
	}

	if((fp = fopen(filename,"w")) == NULL) {
		sprintf(errormsg,"Cannot open: %s",filename);
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return(0);
	}

	num = sat_pop_real();
	if(num < 2) {
		sat_stack_push_string("Number of points must be > 1");
		sat_push_real(1);
		return(0);
	}

	sys_slowOff();

	srand(sys_RTC_seconds());

	for(i=0;i<num;i++) {
		x = 100*(RAND - .5);
		y = 100*(RAND - .5);

		fprintf(fp,"%f %f\n",x,y);
	}

	fclose(fp);
	sat_push_real(0);
	sys_slowOn();
	return(0);
}
