#include <hpgcc49.h>
#include <hpgbmp.h>
#include "hpgpriv.h"

int hpg_get_bmp_info (char *name, int *width, int *height, int *nbcolors)
{
	int Ret = 0;
	FILE *file;

	// Opens the bitmap file
	if (file = fopen (name, "rb"))
	{
		HEADER Header;
		INFOHEADER Info;
					
		// Reads the header
		if (fread ((void *) &Header, 1, sizeof (HEADER), file) == sizeof (HEADER))
		{
			// Checks the format
			if (! strncmp ("BM", (char *) &(Header.type), 2))
			{
				// Reads the header information
				(void) fseek (file, 2, FS_SEEK_CUR);
				if (fread ((void *) &Info, 1, sizeof (INFOHEADER), file) == sizeof (INFOHEADER))
				{
					*width = Info.width;
					*height = Info.height;
					*nbcolors = pow (2, Info.bits);
				}
				else
				{
					Ret = C_ErrReadHeader;
				}
			}
			else
			{
				Ret = C_ErrBadFormat;
			}
		}
		else
		{
			Ret = C_ErrReadHeader;
		}
					
		(void) fclose (file);
	}
	else
	{
		Ret = C_ErrOpenFile;
	}				

	return (Ret);
}

