#include <hpgcc49.h>
#include <hpgraphics.h>
#include "vdefs.h"

extern int triangulate;
extern PREC ymax, ymin, xmax, xmin;

extern int plinesn;
extern polyLine *plines;
extern int pedgesn;
extern polyEdge *pedges;

PREC pxmin, pxmax, pymin, pymax;

/*
void out_bisector(Edge * e)
{
	if (!triangulate) {
		printf("l %f %f %f\n", e->a, e->b, e->c);
	}
}
*/

void out_ep(Edge * e)
{
	if (!triangulate) {
		//printf("e %d", e->edgenbr);
		//printf(" %d ", e->ep[le] != (Site *) NULL ? e->ep[le]->sitenbr : -1);
		//printf("%d\n", e->ep[re] != (Site *) NULL ? e->ep[re]->sitenbr : -1);
		clip_line(e);
	}
}
/*
void out_vertex(Site * v)
{
	if (!triangulate) {
		printf("v %f %f %d\n", v->coord.x, v->coord.y, v->sitenbr);
	}
}

void out_site(Site * s)
{
	if (!triangulate) {
		printf("s %f %f\n", s->coord.x, s->coord.y);
	}
}
*/

void out_triple(Site * s1, Site * s2, Site * s3)
{
	if (triangulate) {
		printf("%d %d %d\n", s1->sitenbr, s2->sitenbr, s3->sitenbr);
	}
}

void plotinit(void)
{
	PREC dx, dy;

	dy = ymax - ymin;
	dx = xmax - xmin;
	/*
	   d = ( dx > dy ? dx : dy) * 1.1 ;
	   pxmin = xmin - (d-dx) / 2.0 ;
	   pxmax = xmax + (d-dx) / 2.0 ;
	   pymin = ymin - (d-dy) / 2.0 ;
	   pymax = ymax + (d-dy) / 2.0 ;
	 */

	if (dx == 0) {
		xmax += dy / 2.0;
		xmin -= dy / 2.0;
	}
	if (dy == 0) {
		ymax += dx / 2.0;
		ymin -= dx / 2.0;
	}

	pxmax = xmax + dx * 0.05;
	pxmin = xmin - dx * 0.05;
	pymax = ymax + dy * 0.05;
	pymin = ymin - dy * 0.05;
/*
	pxmax = round(pxmax * 1000000) / 1000000;
	pxmin = round(pxmin * 1000000) / 1000000;
	pymax = round(pymax * 1000000) / 1000000;
	pymin = round(pymin * 1000000) / 1000000;
*/
}

void clip_line(Edge * e)
{
	Site *s1, *s2;
	PREC x1, x2, y1, y2;

	if (e->a == 1.0 && e->b >= 0.0) {
		s1 = e->ep[1];
		s2 = e->ep[0];
	} else {
		s1 = e->ep[0];
		s2 = e->ep[1];
	}
	if (e->a == 1.0) {
		y1 = pymin;
		if (s1 != (Site *) NULL && s1->coord.y > pymin) {
			y1 = s1->coord.y;
		}
		if (y1 > pymax) {
			return;
		}
		x1 = e->c - e->b * y1;
		y2 = pymax;
		if (s2 != (Site *) NULL && s2->coord.y < pymax) {
			y2 = s2->coord.y;
		}
		if (y2 < pymin) {
			return;
		}
		x2 = e->c - e->b * y2;
		if (((x1 > pxmax) && (x2 > pxmax))
			|| ((x1 < pxmin) && (x2 < pxmin))) {
			return;
		}
		if (x1 > pxmax) {
			x1 = pxmax;
			y1 = (e->c - x1) / e->b;
		}
		if (x1 < pxmin) {
			x1 = pxmin;
			y1 = (e->c - x1) / e->b;
		}
		if (x2 > pxmax) {
			x2 = pxmax;
			y2 = (e->c - x2) / e->b;
		}
		if (x2 < pxmin) {
			x2 = pxmin;
			y2 = (e->c - x2) / e->b;
		}
	} else {
		x1 = pxmin;
		if (s1 != (Site *) NULL && s1->coord.x > pxmin) {
			x1 = s1->coord.x;
		}
		if (x1 > pxmax) {
			return;
		}
		y1 = e->c - e->a * x1;
		x2 = pxmax;
		if (s2 != (Site *) NULL && s2->coord.x < pxmax) {
			x2 = s2->coord.x;
		}
		if (x2 < pxmin) {
			return;
		}
		y2 = e->c - e->a * x2;
		if (((y1 > pymax) && (y2 > pymax))
			|| ((y1 < pymin) && (y2 < pymin))) {
			return;
		}
		if (y1 > pymax) {
			y1 = pymax;
			x1 = (e->c - y1) / e->a;
		}
		if (y1 < pymin) {
			y1 = pymin;
			x1 = (e->c - y1) / e->a;
		}
		if (y2 > pymax) {
			y2 = pymax;
			x2 = (e->c - y2) / e->a;
		}
		if (y2 < pymin) {
			y2 = pymin;
			x2 = (e->c - y2) / e->a;
		}
	}
/*
	printf("plot %d %d %.20f %.20f %.20f %.20f box %f %f %f %f edge %d\n",
		e->reg[le]->sitenbr, e->reg[re]->sitenbr,
		x1, y1, x2, y2, pxmin, pymin, pxmax, pymax, e->edgenbr);

	x1 = round(x1 * 1000000) / 1000000;
	y1 = round(y1 * 1000000) / 1000000;
	x2 = round(x2 * 1000000) / 1000000;
	y2 = round(y2 * 1000000) / 1000000;
*/
	plines[plinesn].a = e->a;
	plines[plinesn].b = e->b;
	plines[plinesn].c = e->c;

	if(y1 > y2 || (y1 == y2 && x1 > x2)) {
		plines[plinesn].u.x = x2;
		plines[plinesn].u.y = y2;
		plines[plinesn].v.x = x1;
		plines[plinesn].v.y = y1;
	}
	else {
		plines[plinesn].u.x = x1;
		plines[plinesn].u.y = y1;
		plines[plinesn].v.x = x2;
		plines[plinesn].v.y = y2;
	}

	pedges[pedgesn].in = e->reg[le]->sitenbr;
	pedges[pedgesn].out = e->reg[re]->sitenbr;
	pedges[pedgesn].n = plinesn;
	pedgesn++;

	pedges[pedgesn].in = e->reg[re]->sitenbr;
	pedges[pedgesn].out = e->reg[le]->sitenbr;
	pedges[pedgesn].n = plinesn;
	pedgesn++;
	plinesn++;

	if (plinesn % ALLOCCHUNK == 0)
		plines = (polyLine *) realloc(plines, (plinesn + ALLOCCHUNK) * sizeof(polyLine));
	if (pedgesn % (2 * ALLOCCHUNK) == 0)
		pedges = (polyEdge *) realloc(pedges, (pedgesn + (ALLOCCHUNK * 2)) * sizeof(polyEdge));
}
