#include <hpgcc49.h>

char getnextdigit(FILE *fp);

int main(void)
{
	FILE *fp1, *fp2;
	signed char c1, c2;
	char *file1, *file2 = "pi1m.txt";
	char errormsg[30], fname[13];
	int num=0, tnum;
	SAT_STACK_ELEMENT e;
	SAT_STACK_DATA d;

	sat_get_stack_element(1,&e);
	sat_decode_stack_element(&d,&e);

	if (d.type == SAT_DATA_TYPE_STRING) {
		file1 = str_unquote(d.sval,'\'');
	}
	else {
		sat_stack_push_string("Missing Filename");
		sat_push_real(1);
		return(0);
	}

	if((fp1 = fopen(file1,"r")) == NULL) {
		strncpy(fname,file1,12);
		fname[12] = '\0';
		sprintf(errormsg,"Cannot read: %s",fname);

		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return(0);
	}

	if((fp2 = fopen(file2,"r")) == NULL) {
		strncpy(fname,file2,12);
		fname[12] = '\0';
		sprintf(errormsg,"Cannot read: %s",fname);

		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return(0);
	}

	sat_stack_drop();
	sys_slowOff();

	while((c1 = getnextdigit(fp1)) != EOF && (c2 = getnextdigit(fp2)) != EOF)
		if(c1 == c2)
			num++;
		else
			break;

	tnum = num;
	if(c1 != EOF)
		tnum++;
	while((c1 = getnextdigit(fp1)) != EOF)
		tnum++;

	fclose(fp1);
	fclose(fp2);

	sat_push_zint_llong(tnum);
	sat_push_zint_llong(num);
	sat_push_real(0);

	sys_slowOn();
	return(0);
}

char getnextdigit(FILE *fp) {
	signed char c;

	while((c = fgetc(fp)) != EOF)
		if(isdigit(c))
			return(c);

	return(EOF);
}
