1     	#include <hpgcc49.h>
2     	
3     	char getnextdigit(FILE *fp);
4     	
5     	int main(void)
6     	{
7     	    FILE *fp1, *fp2;
8     	    signed char c1, c2;
9     	    char *file1, *file2 = "pi1m.txt";
10    	    char errormsg[30], fname[13];
11    	    int num=0, tnum;
12    	    SAT_STACK_ELEMENT e;
13    	    SAT_STACK_DATA d;
14    	
15    	    sat_get_stack_element(1,&e);
16    	    sat_decode_stack_element(&d,&e);
17    	
18    	    if (d.type == SAT_DATA_TYPE_STRING) {
19    	        file1 = str_unquote(d.sval,'\'');
20    	    }
21    	    else {
22    	        sat_stack_push_string("Missing Filename");
23    	        sat_push_real(1);
24    	        return(0);
25    	    }
26    	
27    	    if((fp1 = fopen(file1,"r")) == NULL) {
28    	        strncpy(fname,file1,12);
29    	        fname[12] = '\0';
30    	        sprintf(errormsg,"Cannot read: %s",fname);
31    	
32    	        sat_stack_push_string(errormsg);
33    	        sat_push_real(1);
34    	        return(0);
35    	    }
36    	
37    	    if((fp2 = fopen(file2,"r")) == NULL) {
38    	        strncpy(fname,file2,12);
39    	        fname[12] = '\0';
40    	        sprintf(errormsg,"Cannot read: %s",fname);
41    	
42    	        sat_stack_push_string(errormsg);
43    	        sat_push_real(1);
44    	        return(0);
45    	    }
46    	
47    	    sat_stack_drop();
48    	    sys_slowOff();
49    	
50    	    while((c1 = getnextdigit(fp1)) != EOF && (c2 = getnextdigit(fp2)) != EOF)
51    	        if(c1 == c2)
52    	            num++;
53    	        else
54    	            break;
55    	
56    	    tnum = num;
57    	    if(c1 != EOF)
58    	        tnum++;
59    	    while((c1 = getnextdigit(fp1)) != EOF)
60    	        tnum++;
61    	
62    	    fclose(fp1);
63    	    fclose(fp2);
64    	
65    	    sat_push_zint_llong(tnum);
66    	    sat_push_zint_llong(num);
67    	    sat_push_real(0);
68    	
69    	    sys_slowOn();
70    	    return(0);
71    	}
72    	
73    	char getnextdigit(FILE *fp) {
74    	    signed char c;
75    	
76    	    while((c = fgetc(fp)) != EOF)
77    	        if(isdigit(c))
78    	            return(c);
79    	
80    	    return(EOF);
81    	}
