#include <hpgcc49.h>
#include <tommath.h>

int main()
{
	mp_int a;
	mp_err ret;
	char *s, *buf;
	int c;

	sys_slowOff();

	mp_init(&a);
	s = sat_stack_pop_string_alloc();
	if(s == NULL) {
		sat_stack_push_string("Got NULL String!");
		sat_push_real(1);
		sys_slowOn();
		return(0);
	}

	mp_read_radix(&a, s, 10);
	if((ret = mp_prime_next_prime(&a, 5, 0)) != MP_OKAY) {
		sat_stack_push_string(mp_error_to_string(ret));
		sat_push_real(1);
		sys_slowOn();
		return(0);
	}
	mp_radix_size(&a, 10, &c);
	buf = malloc(c * sizeof(char));
	mp_toradix(&a, buf, 10);

	sat_stack_push_string(buf);
	sat_push_real(0);
	sys_slowOn();
	return(0);
}
