1     	#define  DECNUMDIGITS 5010
2     	#include <decNumber.h>
3     	#include <hpgcc49.h>
4     	#include <hpgraphics.h>
5     	
6     	#ifndef HPAPINE
7     	extern unsigned int __heap_ptr,_heap_base_addr;
8     	int freemem();
9     	#endif
10    	
11    	int decNumberIsPrec(decNumber, decNumber, decNumber, decContext);
12    	int decNumberIsLess(decNumber, decNumber, decContext);
13    	
14    	int main(void) {
15    	    decNumber a, b, A, B, s, k, x, y, t;
16    	    decNumber temp1, temp2, temp3, one, two, four, ten, prec;
17    	    decNumber z;
18    	    decContext set;
19    	    FILE *fp;
20    	    char out[DECNUMDIGITS+1];
21    	    int zz, kk=0;
22    	    int start, end;
23    	#ifndef HPAPINE
24    	    int mem;
25    	
26    	    mem = freemem();
27    	#endif
28    	
29    	    if((fp = fopen("piagm.log","w")) == NULL) {
30    	    	char errormsg[30];
31    	
32    	    	sprintf(errormsg,"Cannot open: %s","piagm.log");
33    	
34    	    	sat_stack_push_string(errormsg);
35    	    	sat_push_real(1);
36    	    	return(0);
37    	    }
38    	
39    	    sys_slowOff();
40    	    clear_screen();
41    	
42    	    printf("PI AGM - Hold down ENTER to exit\n\n");
43    	
44    	    decContextDefault(&set, DEC_INIT_BASE);
45    	      set.traps = 0;
46    	    set.digits = DECNUMDIGITS;
47    	
48    	    decNumberFromString(&a, "1", &set);
49    	    decNumberFromString(&A, "1", &set);
50    	    decNumberFromString(&B, "0.5", &set);
51    	    decNumberFromString(&s, "0.5", &set);
52    	    decNumberFromString(&k, "0", &set);
53    	    decNumberFromString(&x, "0", &set);
54    	    decNumberFromString(&y, "1", &set);
55    	
56    	    decNumberFromString(&one,   "1", &set);
57    	    decNumberFromString(&two,   "2", &set);
58    	    decNumberFromString(&four,  "4", &set);
59    	    decNumberFromString(&ten,  "10", &set);
60    	
61    	    decNumberFromString(&prec, "1E-5000", &set);
62    	
63    	    start = sys_RTC_seconds();
64    	    while(!decNumberIsPrec(x,y,prec,set)) {
65    	    	int start, end;
66    	
67    	    	start = sys_RTC_seconds();
68    	
69    	    	// k = k + 1
70    	    	decNumberAdd(&k, &k, &one, &set);
71    	
72    	    	// status iterations
73    	    	kk++;
74    	    	printf("Iteration: %2d ",kk);
75    	    	fprintf(fp,"Iteration: %2d ",kk);
76    	    	hpg_set_indicator(HPG_INDICATOR_WAIT,HPG_COLOR_BLACK);
77    	
78    	    	// x = y
79    	    	decNumberCopy(&x, &y);
80    	
81    	    	// t = (A+B)/4.0
82    	    	decNumberAdd(&temp1, &A, &B, &set);
83    	    	decNumberDivide(&t, &temp1, &four, &set);
84    	
85    	    	// b = sqrt(B)
86    	    	decNumberSquareRoot(&b, &B, &set);
87    	
88    	    	// a = (a+b)/2.0
89    	    	decNumberAdd(&temp1, &a, &b, &set);
90    	    	decNumberDivide(&a, &temp1, &two, &set);
91    	
92    	    	// A = a^2.0
93    	    	decNumberMultiply(&A, &a, &a, &set);
94    	
95    	    	// B = (A-t)*2.0
96    	    	decNumberSubtract(&temp1, &A, &t, &set);
97    	    	decNumberMultiply(&B, &temp1, &two, &set);
98    	
99    	    	// s = s + (B-A)*2^k
100   	    	decNumberSubtract(&temp1, &B, &A, &set);
101   	    	decNumberPower(&temp2, &two, &k, &set);
102   	    	decNumberMultiply(&temp3, &temp1, &temp2, &set);
103   	    	decNumberAdd(&s, &s, &temp3, &set);
104   	
105   	    	// y = (a+b)^2.0/(2.0 * s)
106   	    	decNumberAdd(&temp1, &a, &b, &set);
107   	    	decNumberMultiply(&temp2, &temp1, &temp1, &set);
108   	    	decNumberMultiply(&temp3, &two, &s, &set);
109   	    	decNumberDivide(&y, &temp2, &temp3, &set);
110   	
111   	    	end = sys_RTC_seconds();
112   	
113   	    	// status digits
114   	    	decNumberSubtract(&z, &y, &x, &set);
115   	    	decNumberAbs(&z, &z, &set);
116   	    	zz=0;
117   	    	while(decNumberIsLess(z,one,set)) {
118   	    		decNumberMultiply(&z, &z, &ten, &set);
119   	    		zz++;
120   	    	}
121   	    	printf("Digits: %4d ",zz);
122   	    	fprintf(fp,"Digits: %4d ",zz);
123   	
124   	    	printf("Tm: %2d",end-start);
125   	    	fprintf(fp,"Tm: %2d\n",end-start);
126   	
127   	    	if(keyb_isAnyKeyPressed())
128   	    		break;
129   	    }
130   	    end = sys_RTC_seconds();
131   	
132   	    printf("\n");
133   	    fprintf(fp,"\n");
134   	    printf("   time(s): %d\n",end-start);
135   	    fprintf(fp,"   time(s): %d\n",end-start);
136   	#ifndef HPAPINE
137   	    printf("bytes used: %d",mem-freemem());
138   	    fprintf(fp,"bytes used: %d\n",mem-freemem());
139   	#endif
140   	    fclose(fp);
141   	
142   	    decNumberToString(&x, out);
143   	    if((fp = fopen("piagm.txt","w")) == NULL) {
144   	    	char errormsg[30];
145   	
146   	    	sprintf(errormsg,"Cannot open: %s","piagm.txt");
147   	
148   	    	sat_stack_push_string(errormsg);
149   	    	sat_push_real(1);
150   	    	return(0);
151   	    }
152   	    fprintf(fp,"%s\n",out);
153   	    fclose(fp);
154   	
155   	    hpg_set_indicator(HPG_INDICATOR_WAIT,HPG_COLOR_WHITE);
156   	    sat_push_real(0);
157   	    beep();
158   	    sys_slowOn();
159   	    WAIT_CANCEL;
160   	    return(0);
161   	}
162   	
163   	int decNumberIsPrec(decNumber a, decNumber b, decNumber c, decContext ctx)
164   	{
165   	    decNumber temp1, temp2;
166   	    decNumber cmp;
167   	
168   	    decNumberSubtract(&temp1, &a, &b, &ctx);
169   	    decNumberAbs(&temp2, &temp1, &ctx);
170   	    decNumberCompare(&cmp, &temp2, &c, &ctx);
171   	    return(decNumberIsNegative(&cmp));
172   	}
173   	
174   	int decNumberIsLess(decNumber a, decNumber b, decContext ctx)
175   	{
176   	    decNumber cmp;
177   	    
178   	    decNumberCompare(&cmp, &a, &b, &ctx);
179   	    return(decNumberIsNegative(&cmp));
180   	}
181   	
182   	#ifndef HPAPINE
183   	int freemem()
184   	{
185   	    register unsigned int stack_ptr asm ("sp");
186   	    unsigned int base;
187   	
188   	    base=(__heap_ptr == 0)? _heap_base_addr:__heap_ptr;
189   	
190   	    return stack_ptr-base;
191   	}
192   	#endif
