#include <hpgcc49.h>

int main(void)
{
	char *filename, *s;
	SAT_STACK_ELEMENT e;
	SAT_STACK_DATA d;
	FILE *fp;

	sat_get_stack_element(1, &e);
	sat_decode_stack_element(&d, &e);
	if (d.type == SAT_DATA_TYPE_STRING) {
		filename = str_unquote(d.sval, '\'');
	} else {
		sat_stack_push_string("Missing Filename");
		sat_push_real(1);
		return (0);
	}

	sat_get_stack_element(2, &e);
	sat_decode_stack_element(&d, &e);
	if (d.type == SAT_DATA_TYPE_STRING) {
		sat_stack_drop();
		s = sat_stack_pop_string_alloc();
	} else {
		sat_stack_push_string("Missing String");
		sat_push_real(1);
		return (0);
	}

	if ((fp = fopen(filename, "w")) == NULL) {
		char errormsg[30];
		char fname[13];

		strncpy(fname, filename, 12);
		fname[12] = '\0';
		sprintf(errormsg, "Cannot open: %s", fname);

		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return (0);
	}

	fprintf(fp, "%s", s);
	fclose(fp);

	sat_push_real(0);
	return (0);
}
