1     	#include <hpgcc49.h>  //the standard HP lib
2     	#include <hpgraphics.h>
3     	
4     	#ifndef HPAPINE
5     	extern unsigned int __heap_ptr,_heap_base_addr;
6     	int freemem();
7     	#endif
8     	
9     	int main(void){
10    	    unsigned int *a, b, c, d = 0, e = 0, f = 10000, g, h = 0;
11    	    int start, end, cc = 0, ndigits;
12    	    FILE *fp;
13    	    char *filename = "spigot.txt";
14    	    char errormsg[40];
15    	#ifndef HPAPINE
16    	    int mem;
17    	
18    	    mem = freemem();
19    	#endif
20    	
21    	    ndigits = sat_pop_real();  //get ndigits from stack
22    	    if(ndigits < 1) {
23    	        sat_push_zint_llong((int)ndigits);
24    	        sat_stack_push_string("PI digits must be > 0");
25    	        sat_push_real(1);
26    	        return(0);
27    	    }
28    	    if(ndigits % 4 != 0)
29    	        ndigits+=4;
30    	    c=(ndigits/4+1)*14;
31    	
32    	    if((fp = fopen(filename,"w")) == NULL) {
33    	        sprintf(errormsg,"Cannot open: %s",filename);
34    	
35    	        sat_stack_push_string(errormsg);
36    	        sat_push_real(1);
37    	        return(0);
38    	    }
39    	
40    	    sys_slowOff();    //max speed
41    	
42    	    if((a=malloc(c*sizeof(*a))) == NULL) {
43    	        sprintf(errormsg,"Cannot allocate %d bytes\n",(int)(c*sizeof(*a)));
44    	        sat_stack_push_string(errormsg);
45    	        sys_slowOn();
46    	        sat_push_real(1);
47    	        return(0);
48    	    }
49    	
50    	    clear_screen();   //clear the screen
51    	    hpg_set_indicator(HPG_INDICATOR_WAIT,HPG_COLOR_BLACK);
52    	
53    	    start = sys_RTC_seconds();  //get start time in seconds since 1/1/1970
54    	    while ((b=c-=14) > 0) {     //logic, compute 4 digits of pi at a time then display
55    	        while(--b > 0) {
56    	            d *= b;
57    	            if (h == 0)
58    	                d += 2000 * f;
59    	            else
60    	                d += a[b] * f;
61    	            g=b+b-1;
62    	            a[b] = d % g;
63    	            d /= g;
64    	        }
65    	        printf("%04d", e + d/f);
66    	        fprintf(fp,"%04d", e + d/f);
67    	        cc+=4;
68    	        if(cc % 32 == 0) {
69    	            printf("\n");
70    	            fprintf(fp,"\n");
71    	            hpg_set_indicator(HPG_INDICATOR_WAIT,HPG_COLOR_BLACK);
72    	        }
73    	        if(keyb_isAnyKeyPressed())  //hold any key to stop, do not use ON
74    	            break;
75    	        d = e =    d % f;
76    	        h = 4;
77    	    }
78    	    end = sys_RTC_seconds();  //get end time in seconds since 1/1/1970
79    	    if(cc % 32 != 0) {
80    	        printf("\n");
81    	        fprintf(fp,"\n");
82    	    }
83    	    printf("\n");
84    	    fprintf(fp,"\n");
85    	    fclose(fp);
86    	
87    	    printf("bytes alloc: %d\n",(ndigits/4+1)*14*(int)sizeof(*a));
88    	    sat_push_zint_llong((ndigits/4+1)*14*(int)sizeof(*a));
89    	    sat_stack_push_string("bytes alloc");
90    	#ifndef HPAPINE
91    	    printf(" bytes used: %d\n",mem-freemem());
92    	    sat_push_zint_llong(mem-freemem());
93    	    sat_stack_push_string("bytes used");
94    	#endif
95    	    printf("    time(s): %d\n",end-start);
96    	    sat_push_zint_llong(end-start);
97    	    sat_stack_push_string("time(s)");
98    	
99    	    printf("     digits: %d\n",cc);
100   	    sat_push_zint_llong(cc);
101   	    sat_stack_push_string("digits");
102   	
103   	    if(end-start == 0) {
104   	        printf("   digits/s: NAN");
105   	        sat_stack_push_string("NAN");
106   	    }
107   	    else {
108   	        printf("   digits/s: %.2f",(float)cc/(float)(end-start));
109   	        sat_push_real(((cc*100)/(end-start) + .5)/100.0);
110   	    }
111   	    sat_stack_push_string("digits/s");
112   	
113   	    sat_push_real(0);
114   	    hpg_set_indicator(HPG_INDICATOR_WAIT,HPG_COLOR_WHITE);
115   	    beep();
116   	    sys_slowOn(); //normal speed
117   	    WAIT_CANCEL;  //loop until ON pressed
118   	    return(0);
119   	}
120   	
121   	#ifndef HPAPINE
122   	int freemem()
123   	{
124   	    register unsigned int stack_ptr asm ("sp");
125   	    unsigned int base;
126   	
127   	    base=(__heap_ptr == 0)? _heap_base_addr:__heap_ptr;
128   	
129   	    return stack_ptr-base;
130   	}
131   	#endif
