1     	#include <hpgcc49.h>
2     	#include <hpgraphics.h>
3     	#include <tommath.h>
4     	
5     	#ifndef HPAPINE
6     	extern unsigned int __heap_ptr,_heap_base_addr;
7     	int freemem();
8     	#endif
9     	
10    	int main()
11    	{
12    	    mp_int q, r, t, k, n, l;
13    	    mp_int r1, n1;
14    	    mp_int temp1, temp2, rmd;
15    	    int numdigits = 0, loops = 0, start, end;
16    	    double maxdigits;
17    	    char buf[4];
18    	    FILE *fp;
19    	    char *filename = "uspi.txt";
20    	#ifndef HPAPINE
21    	    int mem, lowmem = 0;;
22    	#endif
23    	
24    	    maxdigits = sat_pop_real();
25    	    if(maxdigits < 1) {
26    	        sat_push_zint_llong((int)maxdigits);
27    	        sat_stack_push_string("PI digits must be > 0");
28    	        sat_push_real(1);
29    	        return(0);
30    	    }
31    	
32    	    if((fp = fopen(filename,"w")) == NULL) {
33    	        char errormsg[30];
34    	
35    	        sprintf(errormsg,"Cannot open: %s",filename);
36    	
37    	        sat_stack_push_string(errormsg);
38    	        sat_push_real(1);
39    	        return(0);
40    	    }
41    	
42    	    sys_slowOff();
43    	    clear_screen();
44    	
45    	#ifndef HPAPINE
46    	    mem = freemem();
47    	#endif
48    	    mp_init(&q);
49    	    mp_init(&r);
50    	    mp_init(&t);
51    	    mp_init(&k);
52    	    mp_init(&n);
53    	    mp_init(&l);
54    	    mp_init(&r1);
55    	    mp_init(&n1);
56    	    mp_init(&temp1);
57    	    mp_init(&temp2);
58    	    mp_init(&rmd);
59    	
60    	    mp_set_int(&q,1);
61    	    mp_zero(&r);
62    	    mp_set_int(&t,1);
63    	    mp_set_int(&k,1);
64    	    mp_set_int(&n,3);
65    	    mp_set_int(&l,3);
66    	
67    	    hpg_set_indicator(HPG_INDICATOR_WAIT,HPG_COLOR_BLACK);
68    	    start = sys_RTC_seconds();
69    	
70    	    while(numdigits < maxdigits) {
71    	        loops++;
72    	
73    	        mp_mul_d(&q,4,&temp1);
74    	        mp_add(&temp1,&r,&temp1);
75    	        mp_sub(&temp1,&t,&temp1);
76    	        mp_mul(&n,&t,&temp2);
77    	
78    	        if(mp_cmp(&temp1,&temp2) == MP_LT) {
79    	            mp_todecimal(&n, buf);
80    	            printf("%d",atoi(buf));
81    	            fprintf(fp,"%d",atoi(buf));
82    	            numdigits++;
83    	
84    	            if(numdigits % 33 == 0) {
85    	                fprintf(fp,"\n");
86    	                hpg_set_indicator(HPG_INDICATOR_WAIT,HPG_COLOR_BLACK);
87    	#ifndef HPAPINE
88    	                if(freemem() < 25000)
89    	                    hpg_set_indicator(HPG_INDICATOR_BATTERY,HPG_COLOR_BLACK);
90    	#endif
91    	            }
92    	
93    	            mp_sub(&r,&temp2,&r1);
94    	            mp_mul_d(&r1,10,&r1);
95    	
96    	            mp_mul_d(&q,3,&temp1);
97    	            mp_add(&temp1,&r,&temp1);
98    	            mp_mul_d(&temp1,10,&temp1);
99    	            mp_div(&temp1,&t,&temp1,&rmd);
100   	            mp_mul_d(&n,10,&temp2);
101   	            mp_sub(&temp1,&temp2,&n1);
102   	
103   	            mp_mul_d(&q,10,&q);
104   	
105   	            mp_copy(&r1,&r);
106   	            mp_copy(&n1,&n);
107   	        }
108   	        else {
109   	            mp_mul_d(&q,2,&r1);
110   	            mp_add(&r1,&r,&r1);
111   	            mp_mul(&r1,&l,&r1);
112   	
113   	            mp_mul_d(&k,7,&temp1);
114   	            mp_add_d(&temp1,2,&temp1);
115   	            mp_mul(&temp1,&q,&temp1);
116   	            mp_mul(&r,&l,&temp2);
117   	            mp_add(&temp1,&temp2,&temp1);
118   	            mp_mul(&t,&l,&temp2);
119   	            mp_div(&temp1,&temp2,&n1,&rmd);
120   	
121   	            mp_mul(&q,&k,&q);
122   	            mp_add_d(&k,1,&k);
123   	            mp_mul(&t,&l,&t);
124   	            mp_add_d(&l,2,&l);
125   	
126   	            mp_copy(&r1,&r);
127   	            mp_copy(&n1,&n);
128   	        }
129   	
130   	        if(keyb_isAnyKeyPressed())
131   	            break;
132   	
133   	#ifndef HPAPINE
134   	        if(freemem() < 25000 && lowmem == 0) {
135   	            lowmem = numdigits;
136   	            beep();
137   	            hpg_set_indicator(HPG_INDICATOR_BATTERY,HPG_COLOR_BLACK);
138   	        }
139   	
140   	        if(freemem() < 5000)
141   	            break;
142   	#endif
143   	    }
144   	
145   	    end = sys_RTC_seconds();
146   	    fclose(fp);
147   	
148   	    printf("\n\n");
149   	    printf("longest digit: %d digits\n",(int)(log10(256.0)*mp_unsigned_bin_size(&q)));
150   	#ifdef HPAPINE
151   	    printf("  bytes alloc: %d\n",
152   	        mp_unsigned_bin_size(&q) +
153   	        mp_unsigned_bin_size(&r) +
154   	        mp_unsigned_bin_size(&t) +
155   	        mp_unsigned_bin_size(&k) +
156   	        mp_unsigned_bin_size(&n) +
157   	        mp_unsigned_bin_size(&l) +
158   	        mp_unsigned_bin_size(&r1) +
159   	        mp_unsigned_bin_size(&n1) +
160   	        mp_unsigned_bin_size(&temp1) +
161   	        mp_unsigned_bin_size(&temp2) +
162   	        mp_unsigned_bin_size(&rmd)
163   	    );
164   	#else
165   	    printf("   bytes free: %d\n",mem);
166   	    printf("   bytes used: %d\n",mem-freemem());
167   	    if(lowmem)
168   	        printf(" bytes low(d): %d\n",lowmem);
169   	#endif
170   	    printf("      time(s): %d\n",end-start);
171   	    printf("       digits: %d\n",numdigits);
172   	    if(end-start == 0)
173   	        printf("     digits/s: NAN\n");
174   	    else
175   	        printf("     digits/s: %.2f\n",(float)numdigits/(float)(end-start));
176   	    printf("   iterations: %d\n",loops);
177   	    if(end-start == 0)
178   	        printf("interations/s: NAN");
179   	    else
180   	        printf("interations/s: %.2f",(float)loops/(float)(end-start));
181   	
182   	    hpg_set_indicator(HPG_INDICATOR_WAIT,HPG_COLOR_WHITE);
183   	    hpg_set_indicator(HPG_INDICATOR_BATTERY,HPG_COLOR_WHITE);
184   	
185   	    sat_push_real(0);
186   	    beep();
187   	    sys_slowOn();
188   	    WAIT_CANCEL;
189   	    return(0);
190   	}
191   	
192   	#ifndef HPAPINE
193   	int freemem()
194   	{
195   	    register unsigned int stack_ptr asm ("sp");
196   	    unsigned int base;
197   	
198   	    base=(__heap_ptr == 0)? _heap_base_addr:__heap_ptr;
199   	
200   	    return stack_ptr-base;
201   	}
202   	#endif
