#include <hpgcc49.h>
#include <hpstack.h>
#include <hpdir.h>
#include <hpparser.h>
#include <util.h>

int main (void)
{
	entry_t *expr = NULL;
	int Ret;
	
	// Gets the expression from the stack
	if ((Ret = hps_pick_symb (1, &expr)) == HPS_OK)
	{
		double res = 0;
		char *var;
		double val;
		
		// Sets the variables
		(void) hps_convert (1);
		if (prs_alg_first_var (expr, &var) == PRS_OK)
		{
			if (hpd_rcl_real (var, &val) == HPS_OK)
			{
				(void) prs_alg_set_var (var, val);
			}
		}
		while (prs_alg_next_var (expr, &var) == PRS_OK)
		{
			if (hpd_rcl_real (var, &val) == HPS_OK)
			{
				(void) prs_alg_set_var (var, val);
			}
		}
		
		// Evaluates the expression
		if ((Ret = prs_alg_eval (expr, &res)) == PRS_OK)
		{
			// Pushes the result on the stack
			(void) hps_push_real (res);
		}
		else
		{
			(void) hps_push_str (prs_error (Ret));
		}
	}
	else
	{
		(void) hps_push_str (hps_error (Ret));
	}
	
	return (0);
}
