#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>
#include <hpdir.h>

int hpd_rcl_complex (char *name, complex_t *val)
{
	int Ret = HPD_OK;

	if (name && val)
	{
		SAT_OBJ_DSCR *dirobj;

		// Gets the dir object		
		if (dirobj = sat_dir_rclobject (name))
		{
			hpobj_t obj;
			int incr;
							
			// Tries to decode the object
			obj.type = 0;
			if (hps_decode_complex (dirobj->addr, &obj, &incr) == HPS_OK)
			{
				(void) memcpy ((void *) val, (void *) &(obj.data.docmp), sizeof (complex_t));
			}
			else
			{
				Ret = HPD_ERROR_TYPE;
			}
		}
		else
		{
			Ret = HPD_ERROR_NOT_FOUND;
		}
	}
	else
	{
		Ret = HPD_ERROR_PAR;
	}
	
	return (Ret);
}
