#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_code_uint (ULONGLONG val, unsigned *address)
{
	int Ret = HPS_OK;

	if (address)
	{
		int size = 0;

		if ((Ret = hps_objsize_type (DOHXS, (void *) &val, &size)) == HPS_OK)
		{
			unsigned addr;
			
			if (addr = (*address ? *address : (*address = sat_createtemp (size))))
			{
				int nb = nbdigit (val, 16);					// Number of digits in hexa

				// Fills the prologue
				sat_poke (addr, DOHXS, 5);
						
				// Fills the size
				sat_poke (addr + 5, size - 5, 5);			// Object size - prologue size
						
				// Fills the digits
				val2BCD (val, addr + 10 , size - 11, 16);	// Object size - prologue size - size size - sign size
				val2BCD (0, addr + 10 + nb, 16 - nb, 16);
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
