#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_decode_complex (unsigned address, hpobj_t *obj, int *incr)
{
	int Ret = HPS_OK;
	unsigned prolog;
	
	if (obj && incr)
	{
		if (obj->type)
		{
			prolog = obj->type;							// There is no prologue (used by DOARRY)
			*incr = 0;
		}
		else
		{
			prolog = sat_peek (address, 5);
			address += 5;									// Skips the prologue
			*incr = 5;
		}
			
		switch (prolog)
		{
			case DOCMP :
			{
				complex_t *cpx = (complex_t *) &(obj->data);
				
				// Decodes the Re and Im parts
				cpx->re = real2double (address);
				cpx->im = real2double (address + 16);
				
				// Sets the output parameters
				obj->type = DOCMP;
				*incr += 2 * 16;
				
				break;
			}
				
			default :
			{
				Ret = HPS_ERROR_TYPE;
				break;
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
