#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_push (hpobj_t *obj)
{
	int Ret = HPS_OK;
	unsigned addr = 0;			// Address of the new HP object

	if (obj)
	{
		if ((Ret = hps_code (obj, &addr)) == HPS_OK)
		{
			// Pushes the new object onto the stack
			sat_pushptr (addr);
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}

int hps_push_type (int type, void *data)
{
	int Ret = HPS_OK;
	hpobj_t obj;

	// Fills the object
	obj.type = type;
	(void) memcpy ((void *) &(obj.data), data, sizeof (obj.data));

	// Pushes the object
	Ret = hps_push (&obj);
	
	return (Ret);
}

