#include <hpgcc49.h>
#include <hpstack.h>

int hps_roll (int n)
{
	int Ret = HPS_OK;
	int depth;
	
	// Gets the stack depth
	(void) hps_depth (&depth);
	
	// Checks the stack is large enough compared to the asked roll
	if (depth >= n)
	{
		unsigned stack_ptr = sat_peek_sat_addr (SAT_DSKTOP);	// Stack base address
		unsigned a1;
		int i;
		
		// Classic circular shifting loop
		a1 = sat_peek_sat_addr (stack_ptr);
		for (i = 0; i < (n-1); i++)
		{
			sat_poke_sat_addr (stack_ptr + i*5, sat_peek_sat_addr (stack_ptr + (i+1)*5));
		}
		sat_poke_sat_addr (stack_ptr + (n-1)*5, a1);
	}
	else
	{
		Ret = HPS_ERROR_STACK;
	}
	
	return (Ret);
}
