#include <hpgcc49.h>
#include <hpstack.h>

int main(void)
{
	list_t *List = NULL;			// Input list
	
	// Get the input list from the stack
	if (hps_pop_list (&List) == HPS_OK)
	{
		// Process the list

		double Total = 0.0;			// Total amount
		list_t *Output = NULL;		// Output list
		list_t *Elem = NULL;		// Current input element
		
		// Authorize automatic conversion, so that int can be read as double
		hps_convert (1);
		
		// Create the ouput list
		(void) hps_list_create (&Output);
		
		int Ind = 1;
		// Get each element of the input list as a sub-list made of {Name Qty Price}
		while (hps_list_get_list (List, Ind, &Elem) == HPS_OK)
		{
			char *Name;
			double Qty, Price;
			
			// Read the name of the element
			if (hps_list_get_str (Elem, 1, &Name) == HPS_OK)
			{
				// Read Quantity and unit price
				if ((hps_list_get_real (Elem, 2, &Qty) == HPS_OK) &&
					(hps_list_get_real (Elem, 3, &Price) == HPS_OK))
				{
					// Computes new total
					Total += Qty * Price;
				}
				
				// Add the name to the output list
				hps_list_add_str (Output, Name);
			}
			
			// Next element
			Ind++;
		}
		
		// Push the list onto the stack
		(void) hps_push_list (Output);
		
		// Then destroy C lists
		(void) hps_list_destroy (&List);
		(void) hps_list_destroy (&Output);
		
		// Push the total price onto the stack
		hps_push_real (Total);
	}
	
	return (0);
}


