#ifndef __HPGRAPHICS_H
#include <hpgraphics.h>
#endif

#define GS_W 131
#define GS_H 80

int grobshot(int n)
{
	int g, t, x, y;
	unsigned char header[10], p;
	unsigned long int length;
	char filename[9];
	FILE *fp;

	sprintf(filename,"GROB%04d",n);

	if((fp = fopen(filename,"wb")) == NULL) {
		return(1);
	}

	fwrite("HPHP49-C",1,8,fp);

	header[0] = 0x1e;
	header[1] = 0x2b;

	length = (int)ceil(GS_W/8.0) * 2 * GS_H + 15;

	header[2] = (length & 0x0f) << 4;
	header[3] = (length >> 4) & 0xff;
	header[4] = (length >> 12) & 0xff;

	header[5] = GS_H & 0xff;
	header[6] = (GS_H >> 8) & 0xff;
	header[7] = ((GS_W & 0x0f) << 4) | ((GS_H >> 16) & 0x0f);
	header[8] = (GS_W >> 4) & 0xff;
	header[9] = (GS_W >> 12) & 0xff;

	fwrite(header,1,10,fp);

	for(y = 0; y < GS_H; y++) {
		g = 1;
		t = 0;
		for(x = 0; x < GS_W; x++) {
			if((p = hpg_get_pixel(hpg_stdscreen, x, y)))
				t += g;

			g *= 2;

			if(g == 256) {
				fwrite(&t,1,1,fp);
				t = 0;
				g = 1;
			}
		}
		if(g != 1)
			fwrite(&t,1,1,fp);
	}

	fclose(fp);
	return (0);
}
